/* vi: set ts=4 sw=4: */
#include <string.h>
#include <fcntl.h>
#include "names.h"
//#include "physical.h"
//#include "db_mod.h"
#include "iface.h"
#include "abpmString.h"

#include "available_db_manager.h"

using namespace database;


bool available_db_manager::end_transaction() {
	char *error;

	char command[1024];
	int i;

	//if(sqlite_exec(mydb, "END TRANSACTION", available_db_manager::null_callback, NULL, &error))

	for(i=0; i<PKG_NAME; i++) {
		sprintf(command, "CREATE INDEX index%d ON %s (name, version)",
				2 * i, Table_name[i]);
		if(sqlite_exec(mydb, command, available_db_manager::null_callback, NULL, &error))
			fprintf(stderr, "%s:%d: %s\n", __FILE__, __LINE__, error);
			//fprintf(stderr, "%s\n", error);
		sprintf(command, "CREATE INDEX index%d ON %s (dname, dversion)",
				2 * i + 1, Table_name[i]);
		if(sqlite_exec(mydb, command, available_db_manager::null_callback, NULL, &error))
			fprintf(stderr, "%s:%d: %s\n", __FILE__, __LINE__, error);
			//fprintf(stderr, "%s\n", error);
	}

	sprintf(command, "CREATE INDEX details_index ON details (name, version)");
	if(sqlite_exec(mydb, command, available_db_manager::null_callback, NULL, &error))
		fprintf(stderr, "%s:%d: %s\n", __FILE__, __LINE__, error);

	if(sqlite_exec(mydb, "COMMIT", available_db_manager::null_callback, NULL, &error))
		fprintf(stderr, "%s:%d: %s\n", __FILE__, __LINE__, error);
		//fprintf(stderr, "%s\n", error);

	return true;
}


bool available_db_manager::create_tables() {
#ifndef DUMMY
	char *error;
	int i;
	char command[1024];

	sprintf(command, "CREATE TABLE details "
			"(name, version, section, priority, arch, size, maintainer, source, md5, filename, short_desc, long_desc)");

	if(sqlite_exec(mydb, command, available_db_manager::null_callback, NULL, &error)) {
		fprintf(stderr, "%s:%d: %s\n", __FILE__, __LINE__, error);
		//fprintf(stderr, "%s\n", error);
		fprintf(stderr, "command: %s\n", command);
	}

	for(i=0; i<PKG_NAME; i++) {
		sprintf(command,"CREATE TABLE %s (name, version, dname, dversion)",Table_name[i]);
		if(sqlite_exec(mydb, command, available_db_manager::null_callback, NULL, &error)) {
			//fprintf(stderr, "%s\n", error);
			fprintf(stderr, "%s:%d: %s\n", __FILE__, __LINE__, error);
			fprintf(stderr, "command: %s\n", command);
		}
	}
#endif
	return true;
}


int item_length(char **item);

bool available_db_manager::write_to_db(char **item, char *url_prefix) {
	char *command;
	char *error;
	int i;

//	printf("available_db_manager.cpp: write_to_db(): 77: indul\n");
	command = new char[item_length(item) + strlen(url_prefix) + 200];
	/*it's a litle more then I need...*/

	sprintf(command, "INSERT INTO details"
			"(name, version, section, priority, arch, size,"
			" maintainer, source, md5, filename, short_desc, long_desc)"
			"VALUES ('%s', '%s', '%s', '%s', '%s', '%s', '%s', '%s', '%s', '%s%s', '%s', '%s')",
			item[PKG_NAME],
			item[PKG_VERSION],
			item[PKG_SECTION],
			item[PKG_PRIORITY],
			item[PKG_ARCH],
			item[PKG_SIZE],
			item[PKG_MAINTAINER],
			item[PKG_SOURCE],
			item[PKG_MD5],
			url_prefix, item[PKG_FILENAME],
			item[PKG_SHORT_DESC],
			item[PKG_LONG_DESC]
		   );

//	printf("available_db_manager.cpp: write_to_db(): 99: command = %s\n", command);
#ifndef DUMMY
	if(sqlite_exec(mydb, command, available_db_manager::null_callback, NULL, &error)) {
		//fprintf(stderr, "%s\n", error);
		fprintf(stderr, "%s:%d: %s\n", __FILE__, __LINE__, error);
		fprintf(stderr, "command:%s\n", command);
		fprintf(stderr, "Press ENTER to continue...\n");
		while(fgetc(stdin) != '\n');
	}
#endif
//	printf("available_db_manager.cpp: write_to_db(): 108: sqlite_exec megvolt\n");
	for(i=0; i<PKG_NAME; i++)
		if(strcmp(item[i], ""))
			write_deps_to_db(1, item, (Entry_type)i, command);
	/*TODO: file lists and md5 lists from /var/lib/dpkg/info/... */
	delete[] command;
	return true;
}


bool available_db_manager::read_packages_file(char *filename, char *url_prefix) {
	//	FILE *packages;
	//char **result;
	//int nrow, ncolumn;
	//	char *data;
	int pkg_num;
	//char **item;
	package_control_info *info;
	//int i;
	//	int result;
	//	int end_section = 1;

	//	file_reader *fr = new normal_file_reader(STATUS_FILENAME);

	//	data = new char[1024];

//	printf("available_db_manager.cpp: read_packages_file(): 133: indul\n");
	abpmString filenameS(filename);
	physical::read_old_available_db(filenameS, &info, &pkg_num);
//	printf("available_db_manager.cpp: read_packages_file(): 135: read_old_available_db() megvolt\n");
	for(int i=0; i<pkg_num; i++) {
		//		printf("%s\n", info[i].items[PKG_NAME]);
		write_to_db(info[i].items, url_prefix);
	}
//	printf("available_db_manager.cpp: read_packages_file(): 140: write_to_db() megvolt\n");
	//			if(end_section) {
	//				write_to_db(item);
	//				write_stat(item);
	//			}
	//	md5_close_and_free();
	//	delete fr;
	return true;
}

void available_db_manager::search(char *search_str) {
	char *error;
	char *command = new char[strlen(search_str)*2 + 200];
	sprintf(command, "SELECT * FROM details "
			"WHERE short_desc LIKE '%%%s%%' OR long_desc LIKE '%%%s%%'", search_str, search_str);
	if(sqlite_exec(mydb, command, available_db_manager::search_callback, NULL, &error)) {
		fprintf(stderr, "%s:%d: %s\n", __FILE__, __LINE__, error);
		fprintf(stderr, "command:%s\n", command);
	}
	
	delete[] command;
}

void available_db_manager::show(char *search_str) {
	char *error;
	char *command = new char[strlen(search_str)*2 + 200];
	sprintf(command, "SELECT * FROM details "
			"WHERE name LIKE '%s%%'", search_str);
	if(sqlite_exec(mydb, command, available_db_manager::search_callback, NULL, &error)) {
		fprintf(stderr, "%s:%d: %s\n", __FILE__, __LINE__, error);
		fprintf(stderr, "command:%s\n", command);
	}
	delete[] command;
}

abpmVector<abpmString> available_db_manager::find_urls(Package *pkg) {
	char *error;
	char *command = new char[pkg->name.getLength() + strlen(pkg->version->getstring()) + 200];

	sprintf(command, "SELECT filename FROM details WHERE name = '%s' AND version = '%s'",
			pkg->name.getstring(), pkg->version->getstring());
	//	printf("Command : %s\n", command);
	abpmVector<abpmString> retval;
	if(sqlite_exec(mydb, command, available_db_manager::url_callback, (void *)&retval, &error)) {
		fprintf(stderr, "%s\n", error);
		fprintf(stderr, "command: %s\n", command);
	}

	delete[] command;
	return retval;
}

int available_db_manager::url_callback(void *pArg, int argc, char **argv, char **columnNames) {
	abpmVector<abpmString> *urls = (abpmVector<abpmString> *)pArg;
	abpmString url(argv[0]);
	urls->add(url);
	return 0;
}

bool database::create_available_db(Create_mode mode, char **packages_filenames,
		char **url_prefixes, int packages_files_count, abpmString &destdir) {
	
//	printf("available_db_manager.cpp: create_available_db(): 151: indul\n");
	available_db_manager dbgen;
//	printf("available_db_manager.cpp: create_available_db(): 153: konstruktor megvolt\n");

	dbgen.db_init(destdir);
//TODO: Es a hibakezeles?
	dbgen.create_tables();
//	printf("available_db_manager.cpp: create_available_db(): 157: create_tables() megvolt\n");

	if(mode != EMPTY) {
		dbgen.begin_transaction();
//		printf("available_db_manager.cpp: create_available_db(): 161: begin_transaction()\n");
			
		for(int i=0; i<packages_files_count; i++)
			dbgen.read_packages_file(packages_filenames[i], url_prefixes[i]);
//		printf("available_db_manager.cpp: create_available_db(): 164: read_packages_file() megvolt\n");
		dbgen.end_transaction();
	}
	
//	printf("available_db_manager.cpp: create_available_db(): 168: end_transaction() megvolt\n");
	dbgen.db_uninit();
//	printf("available_db_manager.cpp: create_available_db(): 170: return\n");

	return true;
}

bool database::update_available_db(char **packages_filenames, char **url_prefixes,
		int packages_files_count, abpmString &destdir) {
	available_db_manager dbgen;

	dbgen.db_init(destdir);

	dbgen.begin_transaction();
	for(int i=0; i<packages_files_count; i++)
		dbgen.read_packages_file(packages_filenames[i], url_prefixes[i]);
	dbgen.end_transaction();
	dbgen.db_uninit();

	return true;
}

void database::search(char *search_str, abpmString &destdir) {
	available_db_manager dbgen;

	dbgen.db_init(destdir);

	dbgen.search(search_str);
	dbgen.db_uninit();
}
void database::show(char *pkg_name, abpmString &destdir) {
	available_db_manager dbgen;
	dbgen.db_init(destdir);
	dbgen.show(pkg_name);
	dbgen.db_uninit();
}
abpmVector<abpmString> database::find_urls(Package *pkg, abpmString &destdir) {
	available_db_manager dbgen;
	dbgen.db_init(destdir);
	abpmVector<abpmString> retval = dbgen.find_urls(pkg);
	dbgen.db_uninit();
	return retval;
}

bool database::search_package_from_name(char *pkg_name, Pkg_set *result) {
	char command[1024];
	char *error;
	
	sqlite *available = get_available();
	
	sprintf(command, "SELECT name, version FROM details WHERE name = '%s'", pkg_name);
	if(sqlite_exec(available, command, db_manager::search_from_name_callback, (void *)result, &error)) {
		fprintf(stderr, "%s\n", error);
		return false;
	}
	return true;
}

