/* vi: set ts=4 sw=4: */
#ifndef __INSTALLED_DB_MANAGER_H
#define __INSTALLED_DB_MANAGER_H

#include "abpm_types.h"
#include "package.h"
#include "db_manager.h"

namespace database {
	class available_db_manager :public db_manager {
		private:
			//MD5_writer dolgai...
			char md5sum[33];
			FILE *md5file;
			int md5file_opened;
			char *data_filename;
			int data_filename_mem;
			char *filename;
			int filename_mem;
			char *datafilename_need;
			int datafilename_need_mem;
			long pos;

			
		public:
			static int url_callback(void *pArg, int argc, char **argv, char **columnNames);
			available_db_manager() {db_type=AVAILABLE;md5file_opened=0;data_filename_mem=0;filename_mem=0;datafilename_need_mem = 0;}
			
			bool end_transaction();
			bool create_tables();
			bool write_to_db(char **item, char *url_prefix);
			bool read_packages_file(char *conffile_name, char *url_prefix);
			bool write_physicalinfo_to_db(package_control_info *c_info, physical_package_info *ph_info);
			
			//TODO: ez igy nagyon ronda........
			char *write_md5(char **item, char *filename_need);
			void md5_close_and_free();
			void write_stat(char **item);
			void show(char *pkg_name);
			void search(char *search_str);
			abpmVector<abpmString> find_urls(Package *pkg);
	};
};

#endif
