/* vi: set ts=4 sw=4: */
#ifndef __DB_MANAGER_H
#define __DB_MANAGER_H
#include <sqlite.h>
#include "abpm_types.h"
#include "names.h"
namespace database {
	class db_manager {
		protected:
			int utolso;
			sqlite *mydb;
			
		public:
			db_manager() {mydb=NULL;}
			
			static int null_callback(void *pArg, int argc, char **argv, char **columnNames);
			static int count_callback(void *pArg, int argc, char **argv, char **columnNames);
			static int search_callback(void *pArg, int argc, char **argv, char **columnNames);
			static int search_from_name_callback(void *pArg, int argc, char **argv, char **columnNames);

			enum {INSTALLED,AVAILABLE} db_type;
			bool db_init(abpmString &destdir);
			bool db_uninit();
			
			bool begin_transaction();
			virtual bool end_transaction()=0;
			
			char *generate_metapackage_name(char **item);
			
			bool write_deps_to_db(int OR_enable, char **item, Entry_type t, char *command);
			virtual bool write_to_db(char **item, char *url_prefix)=0;
	};
	sqlite *get_installed();
	sqlite *get_available();
};

#endif
