#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "abpm_types.h"
#include "names.h"
#include "installed_db_manager.h"

using namespace database;

char *installed_db_manager::write_md5(char **item, char *filename_need) {
	char *retval;
	
	int i;
	int len;
	char c;
	int proba=0;
	
//	printf("write_md5 filename: %s  csomag:%s\n", filename_need, item[NAME]);
	len = strlen(item[PKG_NAME]) + 40 + strlen(DPKG_INFODIR);
	
	if(data_filename_mem == 0) {
		data_filename_mem = 1024;
		if((data_filename = (char *)malloc(1024)) == NULL) {
			fprintf(stderr, "Not enough memory\n");
			exit(1);
		}
		data_filename[0] = '\0';
	}
	if(data_filename_mem < len) {
		free(data_filename);
		data_filename_mem = len;
		if((data_filename = (char *)malloc(data_filename_mem)) == NULL) {
			fprintf(stderr, "Not enough memory\n");
			exit(1);
		}
		data_filename[0] = '\0';
	}	
	if(filename_mem == 0)
		if((filename = (char *)malloc(1024)) == NULL) {
			fprintf(stderr, "Not enough memory\n");
			exit(1);
		}
//	printf("42. sor\n");
	if(datafilename_need_mem == 0) {
		datafilename_need_mem = 1024;
		if((datafilename_need = (char *)malloc(1024)) == NULL) {
			fprintf(stderr, "Not enough memory\n");
			exit(1);
		}
	}
	if(len > datafilename_need_mem) {
		datafilename_need_mem = len;
		if((datafilename_need = (char *)malloc(len)) == NULL) {
			fprintf(stderr, "Not enough memory\n");
			exit(1);
		}
	}
//#if defined GEN_DB
	sprintf(datafilename_need, DPKG_INFODIR"%s.md5sums", item[PKG_NAME]);
//#elif defined DB_ADD
//	sprintf(datafilename_need, DPKG_INFODIR"md5sums");
//#else
//# error "What do you want to compile?"
//#endif
	
	if(data_filename[0] == '\0' || strcmp(data_filename, datafilename_need)) {
//		printf("rgi filename: \"%s\" j: \"%s\"\n",data_filename,datafilename_need);
		sprintf(data_filename, "%s", datafilename_need);
		if(md5file_opened)
			fclose(md5file);
		if((md5file = fopen(data_filename, "r")) == NULL) {
			fprintf(stderr, "Couldn't open file for reading: %s\n", data_filename);
			md5file_opened = 0;
			return "";
		} else {
			md5file_opened = 1;
			pos = ftell(md5file);
		}
	}
//	printf("61\n");
	
	retval="";
	len = strlen(item[PKG_NAME]) + strlen(item[PKG_VERSION]);
	
	while(!feof(md5file)) {
//		printf("csomag:%s\n", item[NAME]);
		for(i=0; i<32; i++)
			md5sum[i] = fgetc(md5file);
		md5sum[32]='\0';
		if(feof(md5file))
			break;
//		fprintf(stderr, "\tmd5sum = %s\n", md5sum);
		c=fgetc(md5file);
		if(c != ' ' && c != '\t')
			fprintf(stderr, "WARNING: wrong file format in file: %s", data_filename);
		
		while(c == ' ' || c == '\t')
			c = fgetc(md5file);
		
		/* A <csomagnv>.md5sums fjlban nincs benne a teljes fjlnv kezd '/'-je */
		filename[0]='/';
		i = 1;
		while(c != '\n' && !feof(md5file)) {
			if((i & 1023) == 1023)
				if((filename = (char *)realloc((void *)filename, i+1025)) ==NULL) {
					fprintf(stderr, "Not enough memory\n");
					exit(1);
				}
			filename[i] = c;
			c = fgetc(md5file);
			i++;
		}
		filename[i]='\0';
		if(strlen(filename) == 0)
			fprintf(stderr, "WARNING:  wrong file format in file: %s", data_filename);
		
		if(!strcmp(filename, filename_need)) {
			retval = md5sum;
			if(feof(md5file)) {
				fclose(md5file);
				md5file_opened = 0;
			} else
				pos = ftell(md5file);
			break;
		} else if(proba==0) {
			rewind(md5file);
			proba = 1;
		}
		
		if(i >= 1023) {
			free(filename);
			if((filename = (char *)malloc(1024)) == NULL) {
				fprintf(stderr, "Not enough memory\n");
				exit(1);
			}
		}
	}
	if(!strcmp(retval, ""))
		fseek(md5file, pos, SEEK_SET);
//	fprintf(stderr,"md5 vge\n");
//	printf("kimenet: \"%s\"\n", retval);
	return retval;
}

void installed_db_manager::md5_close_and_free() {
//	printf("close\n");
	if(md5file_opened)
		fclose(md5file);
	if(data_filename_mem) {
		free(data_filename);
		data_filename_mem = 0;
	}
	if(filename_mem) {
		free(filename);
		filename_mem = 0;
	}
//	printf("lefutott\n");
}
