#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "names.h"
#include "installed_db_manager.h"
//#include "file_md5s.h"

using namespace database;

void installed_db_manager::write_stat(char **item) {
	char *data_filename;
	FILE *statfile;
	char *command;
	int command_len;
	char *error;
	char *md5;
	char c;
	int line = 1;
	
	char *owner;
	int owner_len;
	char *group;
	int group_len;
	char *filename;
	int filename_len;
	char file_type;
	int mode;
	char *size;
	int size_len;
	
	if((data_filename = (char *) malloc(strlen(item[PKG_NAME]) +
					40 +
					strlen(DPKG_INFODIR)))
			== NULL) {
		fprintf(stderr, "Not enough memory\n");
		exit(1);
	}
//#if defined GEN_DB
	sprintf(data_filename, DPKG_INFODIR"%s.stat", item[PKG_NAME]);
//#elif defined DB_ADD
//	sprintf(data_filename, DPKG_INFODIR"stat");
//#else
//# error "What do you want to compile?"
//#endif
	if((statfile = fopen(data_filename, "r")) == NULL) {
		fprintf(stderr, "Couldn't open file for reading: %s\n", data_filename);
		free(data_filename);
		return;
	}

	if((filename = (char *)malloc(1024)) == NULL) {
		fprintf(stderr, "Not enough memory\n");
		exit(1);
	}
	if((owner = (char *)malloc(1024)) == NULL) {
		fprintf(stderr, "Not enough memory\n");
		exit(1);
	}
	if((group = (char *)malloc(1024)) == NULL) {
		fprintf(stderr, "Not enough memory\n");
		exit(1);
	}
	if((size = (char *)malloc(1024)) == NULL) {
		fprintf(stderr, "Not enough memory\n");
		exit(1);
	}
	if((command = (char *)malloc(1024)) == NULL) {
		fprintf(stderr, "Not enough memory\n");
		exit(1);
	}
	
	while(!feof(statfile)) {
		/* fgetc is the only portable function to read from file.
		 * I could've use a parser kit, but I don't want to link big
		 * libraries to this program.
		 * That's the reason of this long (and ugly) code. */

/*There are 11 fields in a line*/
	
//		printf("csomag:%s\n", item[NAME]);
		do {
			c=fgetc(statfile);
		} while ((c == ' ' || c == '\t' || c == '\n') && !feof(statfile));
		if(feof(statfile))
			break;
		
/* 1 */
		while(c >= '0' && c <= '9') c = fgetc(statfile); /*owner id - we don't intrested*/
		while(c == ' ' || c == '\t') c = fgetc(statfile);
		
//		printf("1. mez\n");
/* 2 */
		owner_len = 0;
		while(c != ' ' && c != '\t') {
			if((owner_len & 1023) == 1023)
				if((owner =(char *) realloc((void *)owner,
								owner_len + 1025)) == NULL) {
					fprintf(stderr, "Not enough memory\n");
					exit(1);
				}
			owner[owner_len] = c;
			c = fgetc(statfile);
			owner_len++;
		}
		owner[owner_len] = '\0';
		while(c == ' ' || c == '\t') c = fgetc(statfile);
//		printf("2. mez\n");
/* 3 */
		while(c >= '0' && c <= '9') c = fgetc(statfile); /*group id - we don't intrested*/
		while(c == ' ' || c == '\t') c = fgetc(statfile);
		
//		printf("3. mez\n");
/* 4 */
		group_len = 0;
		while(c != ' ' && c != '\t') {
			if((group_len & 1023) == 1023)
				if((group = (char *) realloc((void *)group,
								group_len + 1025)) == NULL) {
					fprintf(stderr, "Not enough memory\n");
					exit(1);
				}
			group[group_len] = c;
			c = fgetc(statfile);
			group_len++;
		}
		group[group_len] = '\0';
		while(c == ' ' || c == '\t') c = fgetc(statfile);
		
//		printf("4. mez\n");
/* 5 */
		file_type = c;
		
		while(c != ' ' && c != '\t') c = fgetc(statfile);
		while(c == ' ' || c == '\t') c = fgetc(statfile);
//		printf("5. mez\n");
/* 6 */
		mode = 0;
		while(c >= '0' && c <= '9') {
//			printf("%c\n", c);
			mode *= 8;
			mode += (c - '0');
			c = fgetc(statfile);
		}
//		printf("mode:%d\n", mode);
		if(c != ' ' && c != '\t') {
			fprintf(stderr, "WARNING: bad file format in file %s at line %d\n",
					data_filename, line);
		}
		while(c == ' ' || c == '\t') c = fgetc(statfile);
//		printf("6. mez\n");
/* 7 */
		while(c != ' ' && c != '\t') c = fgetc(statfile);
			/*I don't know what this field is. Usualli it's only a '-'.*/
		while(c == ' ' || c == '\t') c = fgetc(statfile);
//		printf("7. mez\n");
/* 8 */
		while(c != ' ' && c != '\t') c = fgetc(statfile);
			/*I don't know what this field is. Usualli it's only a '-'.*/
		
		while(c == ' ' || c == '\t') c = fgetc(statfile);
//		printf("8. mez\n");
/* 9 */
		size_len = 0;
		if(c == '-') {
			size[0] = '\0';
			c = fgetc(statfile);
		} else {
			while(c != ' ' && c != '\t') {
				if((size_len & 1023) == 1023) {
					if((size = (char *) realloc((void *)size,
									size_len + 1025)) == NULL){
						fprintf(stderr, "Not enough memory\n");
						exit(1);
					} else
						fprintf(stderr,"Ouhhhh. What a big file!! "
								"Do you think the %s file is "
								"correct?\n",
								data_filename);
				}
				size[size_len] = c;
				c = fgetc(statfile);
				size_len++;
			}
			size[size_len] = '\0';
		}
		if(c != ' ' && c != '\t') {
			fprintf(stderr, "WARNING:  bad file format in file %s at line %d\n",
					data_filename, line);
		}
		while(c == ' ' || c == '\t') c = fgetc(statfile);
//		printf("9. mez\n");
/* 10 */
		while(c != ' ' && c != '\t') c = fgetc(statfile);
			/*I don't know what this field is. */
		while(c == ' ' || c == '\t') c = fgetc(statfile);
//		printf("10. mez\n");
/* 11 */
		filename_len = 0;
		while(c != '\n' && !feof(statfile)) {
			if((filename_len & 1023) == 1023)
				if((filename = (char *)realloc((void *)filename,
								filename_len + 1025)) ==NULL) {
					fprintf(stderr, "Not enough memory\n");
					exit(1);
				}
			filename[filename_len] = c;
			c = fgetc(statfile);
			filename_len++;
		}
		filename[filename_len] = '\0';
//		printf("11. mez\n");
/* Now we can create and execute the command*/
		if(file_type == 'f')
			md5 = write_md5(item, filename);
		else
			md5 = "";
		/*Don't free it*/
		
		command_len =
			owner_len + 
			group_len + 
			size_len + 
			filename_len +
			strlen(md5) + /*I think I don't have to count it every time*/
			strlen(item[PKG_NAME]) + 
			strlen(item[PKG_VERSION]) + 
			200;
		
//		printf("command_len = %d\n", command_len);
		if(command_len >= 1023)
			if((command = (char *)malloc(command_len)) ==NULL) {
				fprintf(stderr, "Not enough memory\n");
				exit(1);
			}
		sprintf(command, "INSERT INTO files "
				"(name, version, filename, file_owner, file_group, "
				"type, permission, md5, size) "
				"VALUES ('%s','%s','%s','%s','%s','%c','%d','%s','%s')",
				item[PKG_NAME], item[PKG_VERSION], filename,
				owner, group, file_type, mode, md5, size);
//		printf("command = %s\n", command);
//		fflush(stdout);
		if(sqlite_exec(mydb, command, null_callback, NULL, &error)) {
			fprintf(stderr, "%s\n", error);
			fprintf(stderr, "command:%s\n", command);
			fprintf(stderr, "Press ENTER to continue...\n");
			fgetc(stdin); //debug
		}
//		printf("sqlite_exec vgrehajtva\n");
/*cleaning*/
//		printf("filename_len = %d\n", filename_len);
		if(filename_len >= 1023) {
			free(filename);
			if((filename = (char *)malloc(1024)) == NULL) {
				fprintf(stderr, "Not enough memory\n");
				exit(1);
			}
		}
//		printf("owner_len = %d\n", owner_len);
		if(owner_len >= 1023) {
			free(owner);
			if((owner = (char *)malloc(1024)) == NULL) {
				fprintf(stderr, "Not enough memory\n");
				exit(1);
			}
		}
//		printf("group_len = %d\n", group_len);
		if(group_len >= 1023) {
			free(group);
			if((group = (char *)malloc(1024)) == NULL) {
				fprintf(stderr, "Not enough memory\n");
				exit(1);
			}
		}
//		printf("size_len = %d\n", size_len);
		if(size_len >= 1023) {
			free(size);
			if((size = (char *)malloc(1024)) == NULL) {
				fprintf(stderr, "Not enough memory\n");
				exit(1);
			}
		}
//		printf("command_len = %d\n", command_len);
		if(command_len >= 1023) {
			free(command);
			if((command = (char *)malloc(1024)) == NULL) {
				fprintf(stderr, "Not enough memory\n");
				exit(1);
			}
		}
//		printf("Akkor elvileg ezt ki kell irni!\n");
		line++;
	}
	fclose(statfile);
	free(owner);
	free(group);
	free(size);
	free(filename);
	free(command);
	free(data_filename);
}


