#include <sqlite.h>
#include <string.h>
#include <fcntl.h>
#include <stdlib.h>
#include <stdio.h>
#include "calculate_deps.h"
#include "pkg_set.h"
#include "package.h"
#include "version.h"
#include "src/database/db_manager.h"

using namespace depend_manager;
namespace depend_manager {

sqlite *available;
sqlite *installed;

int is_there_Callback(void *pArg, int argc, char **argv, char **columnNames) {
	if(pArg != NULL && argc == 2) {
		//fprintf(stderr, "callback talalt: %s %s\n", argv[0], argv[1]);
		cb_arg *arg = (cb_arg *)pArg;
		if(arg->pkg->version->dep_ver_chk(argv[1])) {
			Package pkg(argv[0], argv[1]);
			arg->result = 1;
			arg->set->add(pkg);
			//fprintf(stderr, "a verzio stimmel: [%s] [%s]\n", arg->pkg->version->getstring(), argv[1]);
		} //else
			//fprintf(stderr, "a verzio nem stimmel: [%s] [%s]\n", arg->pkg->version->getstring(), argv[1]);
	}
	return 0;
}

int dependency_Callback(void *pArg, int argc, char **argv, char **columnNames) {
	if(pArg != NULL && argc == 2) {
		cb_arg *arg = (cb_arg *)pArg;
		Package pkg(argv[0], argv[1]);
		
		arg->set->add(pkg);
	}
	//fprintf(stderr, "%s:%d:dependency_Callback talalt: %s %s\n", __FILE__,__LINE__,argv[0], argv[1]);
	return 0;
}

int invers_depend_Callback(void *pArg, int argc, char **argv, char **columnNames) {
	if(pArg != NULL && argc == 4) {
		cb_arg *arg = (cb_arg *)pArg;
		//printf("Callback talalt: %s %s provides %s %s\n", argv[0], argv[1], argv[2], argv[3]);
//		if(argv[0][0] == '#')
//			fgetc(stdin);
		if(arg->pkg->version->dep_ver_chk(argv[3])) {
			Package pkg(argv[0], argv[1]);
			arg->set->add(pkg);
			arg->result = 1;
		}
		//fprintf(stderr, "%s:%d: Callback talalt: %s %s provides %s %s\n",__FILE__,__LINE__, argv[0], argv[1], argv[2], argv[3]);
		//arg->set->kiir();
	}
	return 0;
}

bool _newer_version(Package *p1, Package *p2) {
	return *(p1->version) > *(p2->version);
}

bool find_alternatives(Package *pkg, Pkg_set *set,
		int provide_possible, int *result) {

	
	//fprintf(stderr, "%s:%d: finding alternatives of %s-%s\n", __FILE__,__LINE__, pkg->name.getstring(), pkg->version->getstring());
	char *error;
	char *command;
	command = new char[pkg->name.getLength() + strlen(pkg->version->getstring()) + 100];
	
	sprintf(command, "SELECT name, version FROM details WHERE name = '%s'",
			pkg->name.getstring());
	
//	printf("find_alternatives: command:\n  %s\n", command);
	cb_arg arg;
	arg.pkg = pkg;
	arg.set = set;
	arg.result = 0;
	//printf("command <installed>: %s\n", command);
	if(sqlite_exec(available, command, is_there_Callback, (void *)&arg, &error))
		fprintf(stderr, "%s\n", error);
	//fprintf(stderr, "%s:%d: find_alternatives:\n",__FILE__,__LINE__);
	//set->kiir();
	if(sqlite_exec(installed, command, is_there_Callback, (void *)&arg, &error))
		fprintf(stderr, "%s\n", error);
	//fprintf(stderr, "%s:%d: find_alternatives:\n",__FILE__,__LINE__);
	//set->kiir();
	
	if(!arg.result && !provide_possible) {
		delete[] command;
		return false;
	}
	
	
	delete[] command;
	*result += arg.result;
	
	return true;
}

bool _neednt(Package *pkg, Pkg_set *need_to_install) {
	if(need_to_install->in(*pkg))
		return true;
	Pkg_set s;
	if(database::is_installed(pkg, &s))
		if(pkg->version->dep_ver_chk(s.getp(0)->version->getstring()))
			return true;
	
	return false;
}

bool _pkg_inst(Package *pkg, Pkg_set **need_to_install,
		Pkg_set **need_to_remove, void *d_arg) {
	
//	int provide_possible = *(int *)p_provide_possible;
	//fprintf(stderr, "%s,%d: _pkg_inst: pkg.name=%s\n",__FILE__,__LINE__, pkg->name.getstring());
	dep_arg *p_da = (dep_arg *)d_arg;
	
	Package *p;
	if((*need_to_remove)->in_name(*pkg, &p)) {
		if(p->version->dep_ver_chk(pkg->version->getstring())) {
			//fprintf(stderr, "%s,%d: _pkg_inst megdoglott [%s-%s, %s-%s]\n",__FILE__,__LINE__,
			//		pkg->name.getstring(),pkg->version->getstring(),
			//		p->name.getstring(), p->version->getstring());
			return false;
		}
	}
	if((*need_to_install)->in_name(*pkg, &p)) {
		//fprintf(stderr, "%s,%d:pkg=%s-%s\n",__FILE__,__LINE__,p->name.getstring(), p->version->getstring());

		if(pkg->version->dep_ver_chk(p->version->getstring()))
			return true;
	}
	//fprintf(stderr, "%s,%d: _pkg_inst: pkg.name=%s\n",__FILE__,__LINE__, pkg->name.getstring());
	
	Pkg_set *alternatives = new Pkg_set;
	int result = 0;
	if(!find_alternatives(pkg, alternatives, p_da->provide_possible, &result)) {
		delete alternatives;
		return false;
	}

	if(p_da->provide_possible) {
		char *error;
		char *command;
//		printf("command <available>: %s\n", command);
		
		//fprintf(stderr, "%s,%d: _pkg_inst: pkg.name=%s\n",__FILE__,__LINE__, pkg->name.getstring());
		Pkg_set provides;
		
		cb_arg arg;
		arg.pkg = pkg;
		arg.set = &provides;
		arg.result = result;
		command = new char[pkg->name.getLength() + 100];
		sprintf(command, "SELECT name, version, dname, dversion FROM provides "
				"WHERE dname = '%s'",
				pkg->name.getstring());
		if(sqlite_exec(available, command, invers_depend_Callback, (void *)&arg, &error))
			fprintf(stderr, "%s\n", error);
		delete[] command;
		if(!arg.result) {
			delete alternatives;
			return false;
		}
		
		provides.foreach_check_alt(find_alternatives,
				&alternatives, p_da->provide_possible, &(arg.result));
		//if(f == 1) {
		//	delete alternatives;
		//	fprintf(stderr, "%s: %d: inst: %s-%s\n", __FILE__,__LINE__, pkg->name.getstring(), pkg->version->getstring());
		//	return true;
		//}
		if(arg.result == 0) {
			delete alternatives;
			return false;
		}
		
	}
	
	//fprintf(stderr, "%s,%d: _pkg_inst: pkg.name=%s\n",__FILE__,__LINE__, pkg->name.getstring());
	if(alternatives->try_one(_neednt, *need_to_install)) {
		delete alternatives;
		//fprintf(stderr, "%s,%d: _pkg_inst: pkg.name=%s\n",__FILE__,__LINE__, pkg->name.getstring());
		return true;
	}
	

	//fprintf(stderr, "%s:%d: alternatives:\n", __FILE__,__LINE__);
	//alternatives->kiir();
	alternatives->sort(_newer_version);
	//fprintf(stderr, "%s:%d: alternatives:\n", __FILE__,__LINE__);
	//alternatives->kiir();
	
	bool r = alternatives->try_one(_pkg_inst__real_version,
			need_to_install, need_to_remove, d_arg);
	
	//if(!r) {
	//	fprintf(stderr,"%s:%d: _pkg_inst:   %s helyettesitoi:\n", __FILE__,__LINE__, pkg->name.getstring());
	//	alternatives->kiir();
	//}
	delete alternatives;
	return r;
}

void _find_depends(Package *pkg, Pkg_set *depends, void *d_arg, Depend_type type) {
	char *error;
	char *command = new char[pkg->name.getLength() + strlen(pkg->version->getstring()) + 100];
	char *table;
	

	//fprintf(stderr, "%s:%d: finding dependency (%d) of %s-%s\n",__FILE__,__LINE__, type, pkg->name.getstring(), pkg->version->getstring());

	cb_arg ca;
	ca.set = depends;
	ca.pkg = pkg;

	dep_arg *da = (dep_arg *)d_arg;
	depend_list *dl = da->depends;

	switch(type) {
		case INV_DEPEND:
			//Pkg_set provides;
			//db_arg ca1;
			//ca1.set = &provides;
			//ca.pkg = pkg;
			
			//sprintf(command, "SELECT dname, dversion FROM provides "
			//		"WHERE name = '%s'",
			//		pkg->name);
			//if(sqlite_exec(available, command, dependency_Callback, (void *)&ca1, &error))
			//	fprintf(stderr, "%s\n", error);
			sprintf(command, "SELECT name, version, dname, dversion FROM depends "
					"WHERE dname = '%s'",
					pkg->name.getstring());
			//TODO: es ha provide-ol valakit??????
			//TODO: es ha az o verziojara eppen nem vonatkozik a fuggoseg?
			if(sqlite_exec(available, command, invers_depend_Callback, (void *)&ca, &error)) {
				fprintf(stderr, "%s\n", error);
				fprintf(stderr, "%s\n", command);
			}
			break;

		case DEPEND:
		case CONFLICT:
			if(type == DEPEND)
				table="depends";
			else
				table="conflicts";

			sprintf(command, "SELECT dname, dversion FROM %s "
					"WHERE name = '%s' AND version = '%s'",
					table, pkg->name.getstring(), pkg->version->getstring());

			//fprintf(stderr, "%s:%d: command = %s\n",__FILE__,__LINE__, command);
			if(sqlite_exec(available, command, dependency_Callback, (void *)&ca, &error))
				fprintf(stderr, "%s\n", error);
	



			if(type==CONFLICT) {
				sprintf(command, "SELECT name, version, dname, dversion FROM conflicts "
						"WHERE dname = '%s'",
				pkg->name.getstring());
				if(sqlite_exec(available, command, invers_depend_Callback, (void *)&ca, &error))
					fprintf(stderr, "%s\n", error);
				
			}
			break;
	}
	depend_list *l=dl;
	while (l!=NULL) {
		/*if(l->type==type && l->from_pkg == pkg &&
				*(l->from_pkg->version) == *(pkg->version)) {
			fprintf(stderr, "%s:%d: dep added [%s-%s -- %s-%s]\n", __FILE__,__LINE__, l->from_pkg->name.getstring(), l->from_pkg->version->getstring(), l->to_pkg->name.getstring(), l->to_pkg->version->getstring());
			
			depends->add(*(l->to_pkg));
		} else
			fprintf(stderr, "%s:%d: dep notadded [%s-%s -- %s-%s]\n", __FILE__,__LINE__, l->from_pkg->name.getstring(), l->from_pkg->version->getstring(), l->to_pkg->name.getstring(), l->to_pkg->version->getstring());
		fprintf(stderr, "%s:%d: pkg: [%s-%s]\n", __FILE__,__LINE__, pkg->name.getstring(), pkg->version->getstring());
		*/
		
		if(l->type==type) {
			//fprintf(stderr, "%s:%d: type stimmel:%d\n", __FILE__,__LINE__, type);
			if(*(l->from_pkg) == *pkg) {
				//fprintf(stderr, "%s:%d: dep added [%s-%s -- %s-%s]\n", __FILE__,__LINE__, l->from_pkg->name.getstring(), l->from_pkg->version->getstring(), l->to_pkg->name.getstring(), l->to_pkg->version->getstring());

				depends->add(*(l->to_pkg));
			} //else
				//fprintf(stderr, "%s:%d: pkg NEM stimmel [%s-%s -- %s-%s]\n", __FILE__,__LINE__, l->from_pkg->name.getstring(), l->from_pkg->version->getstring(), pkg->name.getstring(), pkg->version->getstring());
		} //else
			//fprintf(stderr, "%s:%d: type NEM stimmel:%d != %d\n", __FILE__,__LINE__, type, l->type);
		
		if(type == CONFLICT && l->type == CONFLICT &&
				l->to_pkg->name == pkg->name &&
				l->to_pkg->version->dep_ver_chk(pkg->version->getstring())) {
			depends->add(*(l->from_pkg));
		}
		l=l->next;
	}
	/*TODO: azert vannak meg mas fuggosegi tipusok is, azt is meg kene csinalni...*/
	delete[] command;
}

bool check_installed(Package *pkg) {
	Pkg_set set;
	cb_arg arg;
	arg.pkg = pkg;
	arg.set = &set;
	arg.result = 0;
	char *error;
	char *command = new char[pkg->name.getLength() + strlen(pkg->version->getstring()) + 100];
	sprintf(command, "SELECT name, version FROM details WHERE name = '%s'",
			pkg->name.getstring());
	if(sqlite_exec(installed, command, is_there_Callback, (void *)&arg, &error))
		fprintf(stderr, "%s\n", error);
	return arg.result>0;
}

bool _pkg_inst__real_version(Package *pkg, Pkg_set **need_to_install,
		Pkg_set **need_to_remove, void *d_arg) {
	//char *command;
	
	//int provide_possible = *(int *)p_provide_possible;
	
	//fprintf(stderr, "%s: %d: inst: %s-%s\n", __FILE__,__LINE__, pkg->name.getstring(), pkg->version->getstring());
	if(check_installed(pkg))
		return true;
	//fprintf(stderr, "%s: %d: inst: %s-%s\n", __FILE__,__LINE__, pkg->name.getstring(), pkg->version->getstring());
	
	dep_arg da;
	da.provide_possible = 1;
	da.depends = ((dep_arg *)d_arg)->depends;
	
	
	Pkg_set *uj_inst = (*need_to_install)->copy();
	Pkg_set *uj_rm = (*need_to_remove)->copy();
	
	uj_inst->add(*pkg);
	
	Pkg_set depends;
	
	_find_depends(pkg, &depends, d_arg, DEPEND);
	
	if(!depends.foreach(_pkg_inst, &uj_inst, &uj_rm, &da)) {
		delete uj_inst;
		delete uj_rm;
		return false;
	}
	
	Pkg_set conflicts;
	
	_find_depends(pkg, &conflicts, d_arg, CONFLICT);
	//fprintf(stderr, "%s:%d:conflicts of %s:\n", __FILE__,__LINE__, pkg->name.getstring());
	//conflicts.kiir();
	
	
	confl_arg ca;
	ca.provide_possible = 1;
	ca.depends = ((dep_arg *)d_arg)->depends;
	//ca.reason = &reason;
	if(!conflicts.foreach(_pkg_rm, &uj_inst, &uj_rm, &ca)) {
		delete uj_inst;
		delete uj_rm;
		fprintf(stderr, "%s:%d:rossz conflict\n", __FILE__,__LINE__);
		return false;
	}
	//fprintf(stderr, "%s:%d:need_to_install::\n", __FILE__,__LINE__);
	//(*need_to_install)->kiir();
	//fprintf(stderr, "%s:%d:uj_inst:\n", __FILE__,__LINE__);
	//uj_inst->kiir();
	
	delete (*need_to_install);
	delete (*need_to_remove);
	*need_to_install = uj_inst;
	*need_to_remove = uj_rm;
	
	//fprintf(stderr, "%s,%d: inst: all right:-D pkg.name=%s\n",__FILE__,__LINE__, pkg->name.getstring());
	return true;
}

bool select_possible_packages(Package *pkg, Pkg_set **alternatives,
		Pkg_set **possible_alternatives, void *p_arg) {
	Package *bad_package_shema = ((upgrade_arg *)p_arg)->bad_pkg_shema; // != NULL   !!!!!
	
	if(!bad_package_shema->version->dep_ver_chk(pkg->version->getstring())) {
		//fprintf(stderr, "%s:%d: possible_package: [%s-%s] (%s)\n",__FILE__,__LINE__,
		//		pkg->name.getstring(), pkg->version->getstring(),
		//		bad_package_shema->version->getstring());
		(*possible_alternatives)->add(*pkg);
	} //else
		//fprintf(stderr, "%s:%d: non possible: [%s-%s] (%s)\n", __FILE__,__LINE__,
		//		pkg->name.getstring(), pkg->version->getstring(),
		//		bad_package_shema->version->getstring());
		
	return true;
}

bool try_to_upgrade(Package *pkg, Pkg_set **install, Pkg_set **remove, void *p_arg) {
	Package *bad_package_shema = ((upgrade_arg *)p_arg)->bad_pkg_shema;
	
	int result;
	
	Pkg_set alternatives;
	Package pkg_shema(pkg->name, abpmString(">= ") + pkg->version->getstring());
	if(!find_alternatives(&pkg_shema, &alternatives, 1, &result)) {
		//fprintf(stderr, "%s:%d:try_to_upgrade [%s]: no alternatives\n", __FILE__,__LINE__, pkg->name.getstring());
		return false;
	}
		
	//fprintf(stderr, "%s:%d:try_to_upgrade:%s\n", __FILE__,__LINE__, pkg->name.getstring());
	//alternatives.kiir();
	Pkg_set _good_alternatives;
	Pkg_set *good_alternatives = &_good_alternatives;
	Pkg_set *p_alternatives = &alternatives;
	if(bad_package_shema == NULL) {
		if(!alternatives.foreach(select_possible_packages, &p_alternatives, &good_alternatives, p_arg))
			return false;
		//fprintf(stderr, "%s:%d:try_to_upgrade:shema!=NULL\n", __FILE__,__LINE__);
	} else {
		good_alternatives = &alternatives;
		//fprintf(stderr, "%s:%d:try_to_upgrade:shema==NULL\n", __FILE__,__LINE__);
	}
	//TODO: sort (newer_version )
	dep_arg da = {1, ((upgrade_arg *)p_arg)->depends };
	bool retval = good_alternatives->try_one(_pkg_inst__real_version, install, remove, &da);
	//fprintf(stderr, "%s:%d:try_to_upgrade [%s] megvolt %d\n", __FILE__,__LINE__, pkg->name.getstring(), retval);
	return retval;
}

bool _pkg_rm(Package *pkg, Pkg_set **need_to_install,
		Pkg_set **need_to_remove, void *d_arg) {
	char *error;
	char *command;
	int provide_possible = ((confl_arg *)d_arg)->provide_possible;
	
	//int provide_possible = *(int *)p_provide_possible;
	confl_arg ca;
	ca.provide_possible = 1;
	ca.depends = ((confl_arg *)d_arg)->depends;
	//ca.conflict_from = pkg;
	//Package *conflict_from = ((confl_arg *)d_arg)->conflict_from;
	
	
	//fprintf(stderr, "%s:%d:_pkg_rm [%s]:\n", __FILE__,__LINE__, pkg->name.getstring());
	
	Package *p;
	if((*need_to_remove)->in_name(*pkg, &p)) {
		/*FIXME: Mi van, ha ugyanaz a csomagnev van ket kulonbozo verzio-kriteriummal?*/
		return true;
	}
	
	if((*need_to_install)->in_name(*pkg, &p))
		if(pkg->version->dep_ver_chk(p->version->getstring())) {
			//fprintf(stderr, "%s:%d:conflict in install [%s-%s -- %s]\n", __FILE__,__LINE__, pkg->name.getstring(), pkg->version->getstring(), p->version->getstring());

			//fprintf(stderr, "%s:%d:install:\n", __FILE__,__LINE__);
			//(*need_to_install)->kiir();
			//fprintf(stderr, "%s:%d:remove:\n", __FILE__,__LINE__);
			//(*need_to_remove)->kiir();
			return false;
		}
	
	
	int len = pkg->name.getLength() + 100;
	command = new char[len];
	
	sprintf(command, "SELECT name, version FROM details WHERE name = '%s'", pkg->name.getstring());
	Pkg_set installed_pkg;
	cb_arg arg;
	arg.set = &installed_pkg; /*it will contain 1 or 0 package*/
	arg.pkg = pkg;
	
	if(sqlite_exec(installed, command, is_there_Callback, (void *)&arg, &error))
		fprintf(stderr, "%s\n", error);
	
	delete[] command;
	Package *real_pkg;
	if(!installed_pkg.in_name(*pkg, &real_pkg)
			/*&& !(*need_to_install)->in_name(pkg, &real_pkg)*/) {
		return true;
	}
	
	Pkg_set depends;
	_find_depends(real_pkg, &depends, d_arg, INV_DEPEND);
	//fprintf(stderr, "%s:%d: pkg_rm (%s) inv_depend:\n", __FILE__,__LINE__, real_pkg->name.getstring());
	//depends.kiir();
	
	if(provide_possible) {
		upgrade_arg ua = {pkg, ((confl_arg *)d_arg)->depends};
		if(try_to_upgrade(pkg, need_to_install, need_to_remove, &ua))
			return true;
	}
	
	Pkg_set *uj_inst = (*need_to_install)->copy();
	Pkg_set *uj_rm = (*need_to_remove)->copy();
	
	uj_rm->add(*real_pkg);
	
	if(!depends.foreach(_pkg_rm, &uj_inst, &uj_rm, &ca)) {
		delete uj_inst;
		delete uj_rm;
		return false;
	}
	
	delete (*need_to_install);
	delete (*need_to_remove);
	*need_to_install = uj_inst;
	*need_to_remove = uj_rm;
	
	return true;
}

bool _install_one(Package *pkg, Pkg_set **need_to_install, Pkg_set **need_to_remove, void *d_arg) {
	dep_arg da;
	da.provide_possible = 0;
	da.depends = ((dep_arg *)d_arg)->depends;
	
	//fprintf(stderr, "%s,%d: _install_one: pkg.name=%s\n",__FILE__,__LINE__, pkg->name.getstring());
	Package *p = pkg->copy();
	
	(*need_to_install)->del(*p);
	
	bool result = _pkg_inst(p, need_to_install, need_to_remove, &da);
	//if(!result)
	//	fprintf(stderr, "%s,%d: _install_one megdoglott [%s]\n",__FILE__,__LINE__, pkg->name.getstring());
	delete p;
	return result;
}

bool _remove_one(Package *pkg, Pkg_set **need_to_install, Pkg_set **need_to_remove, void *d_arg) {
	confl_arg ca;
	ca.provide_possible =0; 
	ca.depends = ((confl_arg *)d_arg)->depends;
	//ca.conflict_from = ((confl_arg *)d_arg)->conflict_from;
	//fprintf(stderr,"%s,%d:remove_one [%s]\n",__FILE__,__LINE__,pkg->name.getstring());
	
	(*need_to_remove)->del(*pkg);
	
	bool result = _pkg_rm(pkg, need_to_install, need_to_remove, &ca);
	return result;
}

bool pkg_inst(Pkg_set **install, Pkg_set **remove, depend_list *additional_depends) {
//	int disable_provide = 0;
	dep_arg arg;
	arg.provide_possible = 0;
	arg.depends=additional_depends;
	//printf("%s,%d:install:\n",__FILE__,__LINE__);
	//(*install)->kiir();
	//printf("%s,%d:remove:\n",__FILE__,__LINE__);
	//(*remove)->kiir();
	return (*install)->foreach(_install_one, install, remove, &arg);
}

bool pkg_remove(Pkg_set **install, Pkg_set **remove, depend_list *additional_depends) {
//	int disable_provide = 0;
	confl_arg ca;
	ca.provide_possible = 0;
	ca.depends=additional_depends;
	//ca.conflict_from=NULL;
	return (*remove)->foreach(_remove_one, install, remove, &ca);
}

void init(abpmString &destdir) {
	
	database::db_init(destdir);
	available = database::get_available();
	installed = database::get_installed();
}

bool add_upgraded_package_to_remove(Package *pkg, Pkg_set **install, Pkg_set **remove, void *unused) {
	Pkg_set s;
	if(database::is_installed(pkg, &s)) {
		(*remove)->add(*(s.getp(0)));
		//fprintf(stderr, "%s:%d: remove-hoz: %s\n", __FILE__,__LINE__, pkg->name.getstring());
	} //else
		//fprintf(stderr, "%s:%d: remove-hoz NEM: %s\n", __FILE__,__LINE__, pkg->name.getstring());
		
	return true;
}

bool calculate_deps_level1(Pkg_set **install, Pkg_set **remove, abpmString db_destdir) {
	init(db_destdir);
	bool retval;
	//fprintf(stderr, "%s:%d: starting level1. install:\n",__FILE__,__LINE__);
	//(*install)->kiir();
	//fprintf(stderr, "%s:%d: remove:\n",__FILE__,__LINE__);
	//(*remove)->kiir();
	retval = pkg_remove(install, remove, NULL);
	if(retval)
		retval = pkg_inst(install, remove, NULL);
	if(retval)
		retval = (*install)->foreach(add_upgraded_package_to_remove, install, remove, NULL);
	//close_db();
	return retval;
}


void _ph_info_add_to_set(physical_package_info *info, Pkg_set *set) {
	for(int i=0; i<info->size(); i++) {
		Package p((*info)[i].filename, "0.0");
		set->add(p);
	}
}



struct pkg_dep_l2_arg {
	depend_list **dl;
	abpmString destdir;
};

struct add_additional_conflict_arg {
	Package *pkg;
	depend_list **dl;
	abpmString destdir;
};

bool add_additional_conflict(Package *filename, Pkg_set **install, Pkg_set **remove, void *p_arg) {

	Package *p;
	abpmString destdir = ((add_additional_conflict_arg *)p_arg)->destdir;
	database::file_conflict(filename->name.getstring(), &p, destdir);
	Package *pkg = ((add_additional_conflict_arg *)p_arg)->pkg;
	if(p==NULL)
		return true;
	//fprintf(stderr, "%s,%d: kozos file: [%s], file=[%s]\n", __FILE__,__LINE__,p->name.getstring(), filename->name.getstring());

	if((*remove)->in(*p)/* || pkg->name == p->name*/) {
//		delete p;
		return true;
	}
	depend_list **dl = ((add_additional_conflict_arg *)p_arg)->dl;
	if(*dl==NULL) {
		*dl = new depend_list(pkg, p, CONFLICT);
		//fprintf(stderr, "%s,%d: kozos file: [%s]\n", __FILE__,__LINE__, pkg->name.getstring());
	} else
		(*dl)->add_depend(pkg, p, CONFLICT);
	//fprintf(stderr, "%s,%d: conflict: [%s-%s] [%s-%s]\n", __FILE__,__LINE__,p->name.getstring(), p->version->getstring(), pkg->name.getstring(), pkg->version->getstring());
//	delete p;
	return true;
};


bool pkg_dep_l2(Package *pkg, Pkg_set **install, Pkg_set **remove, void *p_arg) {
	char *filename;
	abpmString destdir = ((pkg_dep_l2_arg *)p_arg)->destdir;
	if(!media::get_package(pkg->name, pkg->version, &filename, destdir)) {
		fprintf(stderr, "Couldn't fetch package: %s\n", pkg->name.getstring());
		return false;
	}
	
	physical_package_info info;
//	physical::deb_get_physical_info(filename, &info);
	physical::deb_get_physical_info(filename, &info);
	Pkg_set t;
	_ph_info_add_to_set(&info, &t);
	depend_list **dl = ((pkg_dep_l2_arg *)p_arg)->dl;
	add_additional_conflict_arg c_arg;
	c_arg.pkg = pkg;
	c_arg.dl = dl;
	c_arg.destdir=destdir;
	return t.foreach(add_additional_conflict, install, remove, (void *)&c_arg);
}


bool calculate_deps_level2(Pkg_set **install, Pkg_set **remove, Pkg_set *orig_install, Pkg_set *orig_remove, abpmString db_destdir) {
	bool retval = true;
	
	init(db_destdir);

	depend_list *dl = NULL;

	pkg_dep_l2_arg l2_arg;
	l2_arg.dl = &dl;
	l2_arg.destdir=db_destdir;
	
	if(!(*install)->foreach(pkg_dep_l2, install, remove, (void *)&l2_arg)) {
		//fprintf(stderr, "%s,%d:pkg_dep_l2 meghalt\n",__FILE__,__LINE__);
		retval=false;
	}
	//fprintf(stderr, "%s,%d:pkg_dep_l2 vege\n",__FILE__,__LINE__);
	if(dl != NULL) {
		depend_list *l=dl;
		while(l!=NULL) {
			//fprintf(stderr,"%s:%d:conflict: %s-%s <-> %s-%s\n",__FILE__,__LINE__,
			//		l->from_pkg->name.getstring(), l->from_pkg->version->getstring(),
			//		l->to_pkg->name.getstring(), l->to_pkg->version->getstring());
			l=l->next;
		}
	}
	dep_arg da = {1, dl};
	confl_arg ca = {1, dl};
	if(retval) {
		retval = (*install)->foreach(_install_one, install, remove, &da);
		//printf("%s,%d:install one megvolt: %d\n",__FILE__,__LINE__, retval);
	}
	if(retval)
		retval = (*remove)->foreach(_remove_one, install, remove, &ca);
	if(retval)
		retval = (*install)->foreach(add_upgraded_package_to_remove, install, remove, NULL);
	
	//close_db();
	return retval;
}

void depend_list::add_depend(Package *from, Package *to, Depend_type t) {
	depend_list *l=this;
	while(l) {
		if(*(l->from_pkg) == from && *(l->to_pkg) == to && type == t)
			return;
		l=l->next;
	}
	
	last->next = new depend_list(from,to,type);
	last=last->next;
}

} /*namespace depend_manager*/
