/* vi: set ts=4 sw=4: */
#ifndef __INSTALL_H
#define __INSTALL_H
#include "package.h"
#include "depm_types.h"
#include <sqlite.h>

namespace depend_manager {
	struct cb_arg {
		int result;
		Pkg_set *set;
		Package *pkg;
	};
	
	class depend_list {
			depend_list *last;
		public:
			Depend_type type;
			Package *from_pkg;
			Package *to_pkg;
			depend_list *next;

			depend_list(Package *from,Package *to, Depend_type t) {from_pkg=from->copy(); to_pkg=to->copy(); type=t; next=NULL;last=this;}
			~depend_list() {delete from_pkg; delete to_pkg; if(next) delete next;}
			void add_depend(Package *from, Package *to, Depend_type t);
//			bool find_from(Package *from, Package *to);
//			bool find_to(Package *to, Package *from);
	};

	struct dep_arg {
		int provide_possible;
		depend_list *depends;
	};
	struct confl_arg {
		int provide_possible;
		depend_list *depends;
		//Package *reason;
	};
	struct upgrade_arg {
		Package *bad_pkg_shema;
		depend_list *depends;
	};

	extern sqlite *available;
	extern sqlite *installed;

	void _max_version(Package *pkg, Package *ref_pkg);
	Package *choose(Pkg_set *set);

	bool _pkg_inst__real_version(Package *pkg, Pkg_set **need_to_install, Pkg_set **need_to_remove,
			void *p_provide_possible);
	bool _pkg_inst(Package *pkg, Pkg_set **need_to_install, Pkg_set **need_to_remove,
			void *p_provide_possible);
	bool _pkg_rm(Package *pkg, Pkg_set **need_to_install, Pkg_set **need_to_remove,
			void *p_provide_possible);
	
	int is_there_Callback(void *pArg, int argc, char **argv, char **columnNames);
	int dependency_Callback(void *pArg, int argc, char **argv, char **columnNames);
	int invers_depend_Callback(void *pArg, int argc, char **argv, char **columnNames);
	
	bool _install_one(Package *pkg, Pkg_set **need_to_install, Pkg_set **need_to_remove, void *unused);
		
	bool pkg_inst(Pkg_set **install, Pkg_set **remove, depend_list *additional_depends);
	bool pkg_remove(Pkg_set **install, Pkg_set **remove, depend_list *additional_depends);
	void init(abpmString &destdir);
	void close_db();
	
	/*
	bool calculate_deps_level1(Pkg_set **install, Pkg_set **remove);
	bool calculate_deps_level2(Pkg_set **install, Pkg_set **remove);
	
	iface.h-ban...
	*/
	
};
#endif
