#include "package.h"
#include <string.h>
#include "version.h"

Package *Package::copy() {
	//fprintf(stderr, "%s,%d: Package copy: name=%s\n", __FILE__,__LINE__, name);
	return new Package(*this);
}

Package::Package(abpmString &n, Version_iface *v): name(n) {
	if(v == NULL)
		version = new Version((const char *)NULL);
	else
		version = v->copy();
}


Package::Package(const char *n, const char *v): name(n) {
	version = new Version(v);
}

Package::Package(Package& pkg): name(pkg.name) {
	version = pkg.version->copy();
}

Package::~Package() {
	if(version != NULL)
		delete version;
}

bool Package::equals(Package *p) {
	return ((!strcmp(p->name, name)) && (*(p->version) == *version));
}

bool Package::operator==(Package *p) {
	return equals(p);
}

bool Package::operator==(Package &p) {
	return equals(&p);
}
