/* vi: set ts=4 sw=4: */
#include "package.h"
#include "pkg_set.h"
#include <stdio.h>
#include <string.h>

/*
int Pkg_set::where_is_prev(Package *pkg, pkg_list **prev, Search_part part) {
	pkg_list *p = first;
	*prev = NULL;
	
	while(p != NULL) {
		switch(part) {
			case NAME:
				if(!strcmp(p->pkg->name, pkg->name))
					return 1;
				break;
			case VERSION:
				if(*(p->pkg->version) == *(pkg->version))
					return 1;
				break;
			case ALL:
				if(!strcmp(p->pkg->name, pkg->name) && 
						*(p->pkg->version) == *(pkg->version))
					return 1;
				break;
		}
		*prev = p;
		p = p->next;
	}
	return 0;
}

void Pkg_set::del(Package *pkg) {
	
	pkg_list *prev;
	pkg_list *to_delete;
	
	if(where_is_prev(pkg, &prev)) {
		if(prev == NULL) {
			to_delete = first;
			first = first->next;
			if(first == NULL)
				last = NULL;
		} else {
			to_delete = prev->next;
			prev -> next = prev->next->next;
			if(prev->next == NULL)
				last = prev;
		}
		delete to_delete->pkg;
		delete to_delete;
	}
}

int Pkg_set::in(Package *pkg, Package **there) {
	pkg_list *prev;
	int result = where_is_prev(pkg, &prev);
	if(result && there != NULL) {
		if(prev != NULL)
			*there = prev->next->pkg;
		else
			*there = first->pkg;
	}
	return result;
}
*/

bool Pkg_set::in_name(Package &pkg, Package **there) {
	for(int i=0; i<_contents->size(); i++) {
		Package *tp = _contents->getp(i);
		//fprintf(stderr, "%s,%d: tp->name=%s, pkg->name=%s\n",__FILE__,__LINE__,tp->name.getstring(),pkg->name.getstring());
		if(tp->name == pkg.name) {
			if(there !=NULL)
				*there=tp;
			//fprintf(stderr, "%s,%d\n");
			return true;
		}
	}
	return false;
}
/*
Pkg_set *Pkg_set::copy() {
	Pkg_set *set = new Pkg_set;
	pkg_list *p = first;
	while(p!=NULL) {
		set->add(p->pkg);
		p=p->next;
	}
	return set;
}
*/
bool Pkg_set::foreach_check_alt(bool (*func)(Package *, Pkg_set *, int, int *),
		Pkg_set **set, int provide_possible, int *result) {
	Pkg_set *s = (*set)->copy();
	bool f;
	
	for(int i=0; i<_contents->size(); i++) {
		Pkg_set *save = s->copy();
		f = (*func)(_contents->getp(i), s, provide_possible, result);
		if(f == true) {
			delete s;
			delete save;
			return f;
		} else if(f == false) {
			delete s;
			s = save;
		} else
			delete save;
	}
	delete (*set);
	*set = s;
	return 2;
}

bool Pkg_set::foreach(bool (*func)(Package *, Pkg_set **, Pkg_set **, void *),
		Pkg_set **need_to_install, Pkg_set **need_to_remove, void *user_data) {
//	printf("foreach jon\n");
	
	Pkg_set *install_copy = (*need_to_install)->copy();
	Pkg_set *remove_copy = (*need_to_remove)->copy();
	
	for(int i=0; i<_contents->size(); i++) {
//		printf("foreach...\n");
		if((*func)(_contents->getp(i), &install_copy, &remove_copy, user_data) == 0) {
			delete install_copy;
			delete remove_copy;
			return false;
		}
	}
	delete (*need_to_install);
	delete (*need_to_remove);
	*need_to_install = install_copy;
	*need_to_remove = remove_copy;
	return true;
}

bool Pkg_set::try_one(bool (*func)(Package *, Pkg_set **, Pkg_set **, void *),
		Pkg_set **need_to_install, Pkg_set **need_to_remove, void *user_data) {
	
	Pkg_set *install_copy = (*need_to_install)->copy();
	Pkg_set *remove_copy = (*need_to_remove)->copy();
	
	for(int i=0; i<_contents->size(); i++) {
		if((*func)(_contents->getp(i), &install_copy, &remove_copy, user_data) == 1) {
			delete (*need_to_install);
			delete (*need_to_remove);
			*need_to_install = install_copy;
			*need_to_remove = remove_copy;
			return 1;
		}
	}
	delete install_copy;
	delete remove_copy;
	return 0;
}

bool Pkg_set::try_one(bool (*func)(Package *, Pkg_set *), Pkg_set *need_to_install) {
	for(int i=0; i<_contents->size(); i++)
		if((*func)(_contents->getp(i), need_to_install) == 1)
			return true;
	return false;
}


/*
void Pkg_set::sort(bool (*less)(Package *, Package *)) {
	
	if(first == NULL)
		return;
	
	pkg_list *new_list = first;
	pkg_list *l=first->next;
	pkg_list *k, *e, *n;
	
	first->next = NULL;
	last = first;
	
	while(l != NULL) {
		
		n = l->next;
		
		e = NULL;
		k = new_list;
		while(k != NULL) {
			if((*func)(k->pkg, l->pkg))
				break;
			e = k;
			k = k->next;
		}
		
		if(e == NULL) {
			l->next = new_list;
			new_list = l;
		} else {
			l->next = k;
			e->next = l;
			if(k == NULL)
				last = l;
		}

		l = n;
	}
	first = new_list;
}

Pkg_set::~Pkg_set() {
	pkg_list *p;
	
	while(first != NULL) {
		p = first;
		first = p->next;
		delete p->pkg;
		delete p;
	}
}
*/
//Debug
void Pkg_set::kiir() {
	fprintf(stderr, "%s,%d: size:%d\n", __FILE__,__LINE__,_contents->size());
	for(int i=0; i<_contents->size(); i++)
		fprintf(stderr,"  Name = %s Version = %s\n", _contents->get(i).name.getstring(), _contents->get(i).version->getstring());
}
