#ifndef __ABPM_VECTOR_H
#define __ABPM_VECTOR_H
#include <stdio.h>

template <class T>
class abpmVector {
	private:
		int num;
		T **data;
		bool delete_contents_at_destroy;
	public:
		abpmVector() {delete_contents_at_destroy=true, data=NULL; num=0;}
		void set_no_delete_contents() {delete_contents_at_destroy=false;}
	//	void add(T& element);
		int size() {return num;}

		inline void add(T &element) {
			T **newdata=new T*[num + 1];
			for(int i=0; i<num; i++)
				newdata[i]=data[i];
			newdata[num] = new T(element);
			num++;
			if(data != NULL)
				delete[] data;
			data=newdata;
		}
		inline T operator[](int n) {
			if(n>=num || n<0)
				//throw valami...
				return *(data[num-1]);
			return *(data[n]);
		}
		inline T get(int n) {
			if(n>=num || n<0)
				return *(data[num-1]);
			return *(data[n]);
		}
		inline T *getp(int n) {
			if(n>=num || n<0)
				return NULL;
			return data[n];
		}
		
		abpmVector(T*elements, int num_of_elements=1) {
			data=NULL;
			num=0;
			add(elements,num_of_elements);
		}
		inline bool in(T &t) {
			for(int i=0; i<num; i++)
				if(t==*data[i])
					return true;
			return false;
		}
		inline bool in(T *t) {return in(*t);}
		
		inline int find(T &t) {
			for(int i=0; i<num; i++)
				if(t==*data[i])
					return i;
			return -1;
		}
		inline int find(T *t) {return find(*t);}
		
		//The first urgument of "greater" function must be greater when it returns true.
		inline void sort(bool (*greater)(T *t, T *t)) {
			for(int i=1; i<num; i++)
				for(int j=num-1; j>=i; j--)
					if(greater(data[j], data[j-1])) {
						T *tmp = data[j];
						data[j] = data[j-1];
						data[j-1] = tmp;
					}
		}
		
		inline virtual ~abpmVector() {
			if(delete_contents_at_destroy)
				for(int i=0; i<num; i++)
					delete data[i];
			delete[] data;
		}	
};

/*template <class T>
void abpmVector<T>::add(T *elements, int num_of_elements) {
	T **newdata=new T*[num+num_of_elements];
	for(int i=0; i<num; i++)
		newdata[i]=data[i];
	for(int i=0; i<num_of_elements; i++)
		newdata[i+num] = &(elements[i]);
	num+=num_of_elements;
	if(data != NULL)
		delete[] data;
	data=newdata;
}

template <class T>
inline T abpmVector<T>::operator[](int n) {
	if(n>=num || n<0)
		//throw valami...
		return *(data[num-1]);
	return *(data[n]);
}

template <class T>
inline abpmVector<T>::abpmVector(T*elements, int num_of_elements) {
	data=NULL;
	num=0;
	add(elements,num_of_elements);
}
*/
#endif


