/* vi: set ts=4 sw=4: */
#include <unistd.h>
#include "abpm_types.h"
#include <stdio.h>
#include "iface.h"
#include "abpmString.h"
#include "abpmVector.h"
#include "utils.h"
#include "package.h"
#include "pkg_set.h"

using namespace journal;

void journal::begin_transaction(Pkg_set *to_install, Pkg_set *to_remove) {
	fprintf(stderr, "%s: %d: begin transaction\n", __FILE__,__LINE__);
	abpmString journal_dir(ABPM_DATADIR"/journal");
	FILE *f=fopen(journal_dir+"/last_transaction", "a");
	fprintf(f, "-i\n");
	for(int i=0; i<to_install->size(); i++)
		fprintf(f, "%s\n", to_install->getp(i)->name.getstring());
	fprintf(f, "-r\n");
	for(int i=0; i<to_remove->size(); i++)
		fprintf(f, "%s\n", to_remove->getp(i)->name.getstring());
	fclose(f);
	fprintf(stderr, "%s: %d: / begin transaction\n", __FILE__,__LINE__);

}
void journal::begin_package_installing(Package *pkg) {}
void journal::end_package_unpacking(Package *pkg) {}
void journal::end_package_installing(Package *pkg) {}
void journal::begin_package_removing(Package *pkg) {}
void journal::end_package_removing(Package *pkg) {}

void journal::end_transaction_normaly() {
	abpmString journal_dir(ABPM_DATADIR"/journal");
	unlink(journal_dir+"/last_transaction");
	//FIXME: itt azert lenne mit ellenorizni...
}

abpmString readword(FILE *f) {
	abpmString result;
	//TODO: ezt lehet gyorsitani...
	char c;
	while (!feof(f)) {
		c = fgetc(f);
		if(!whitespace(c))
			result+=c;
		else
			break;
	}
	return result;
}

abpmVector<abpmString> journal::failed_transaction() {
	abpmVector<abpmString> result;
	
	abpmString journal_dir(ABPM_DATADIR"/journal");
	FILE *f=fopen(journal_dir+"/last_transaction", "r");
	if(f==NULL)
		return result;
	while(!feof(f)) {
		abpmString w = readword(f);
		result.add(w);
	}
	return result;
}

bool journal::check_journal() {
	abpmString journal_dir(ABPM_DATADIR"/journal");
	mkdir_p(journal_dir);
	if(is_file(journal_dir+"/last_transaction"))
		return false;
	return true;
}

