/* vi: set ts=4 sw=4: */
#ifndef __DOWNLOADER_H
#define __DOWNLOADER_H

struct downloader_thread_arg {
	char *host;
	char *file;
	char *out_filename;
};

class downloader {
	private:
		char *tmp_filename;
		char *real_filename;
	protected:
		char *host;
		size_t offset;
		int cmd_sock;
		
		ssize_t length; /*Length of the file, or -1 if the length is unknown.*/
		int out_fd;
		int sock;
		bool tcp_connect(int port);
		bool tcp_connect_ip4(char *ip, int port);
		bool tcp_connect_ip6(char *ip, int port);
		bool sendall(int socket, char *buf, size_t bytes);
		bool recv_data_to_file();
		bool create_tmp_file(bool can_append);
		bool move_to_real_file();
		inline downloader() {tmp_filename = NULL;}
		inline downloader(char *hostname, char *out_file) {host = hostname; real_filename = out_file, tmp_filename = NULL;}
		inline ~downloader() {if(tmp_filename == NULL) delete[] tmp_filename;}
};

#endif
