#ifndef __FTP_DOWNLOADER_H
#define __FTP_DOWNLOADER_H

#include <pthread.h>
#include "downloader.h"

#define BUF_SIZE 1024

class net_reader {
	private:
		bool _eof;
		int fd;
		char buf[1024];
		int recv_bytes;
		int read_bytes;
		char get_char();
	public:
		inline net_reader(int file_descriptor) {fd = file_descriptor; recv_bytes = read_bytes = 0; _eof = false;}
		inline bool eof() {return _eof;}
		char *next_line();
};

class ftp_downloader :public downloader {
	private:
		char buf[BUF_SIZE];
		ssize_t bytes_in_buf;
		bool download_result;
		pthread_t dl_thread;
		
		char *server_hostname;
		char *file_path_in_server;
		char *output_filename;
		
		int recv_result_line();
		bool protocol(char *filename);
		bool _download(char *file);
		bool create_data_sock();
		bool ftp_downloader::start_download();
		bool finish_connection();
		bool get_important_string(char *expected_start, char **imp_str);
		static void *data_download_thread(void *classptr);
		net_reader *nr;
	public:
		inline ftp_downloader(char *hostname, char *out_file):downloader(hostname, out_file) {}
		static bool download(char *hostname, char *file, char *out_file);
		static void *downloader_thread(void *_arg);
		void _data_download();
		//static void *_data_download_thread(void *classptr);
};

#endif
