#include <stdio.h>
#include <sqlite.h>
#include <string.h>
#include <fcntl.h>
#include <stdlib.h>

#include "utils.h"
#include "iface.h"

#define LISTS_DIR "/tmp/abpm/lists/"

using namespace media;

template <class T>
T *myrealloc(T *orig_array, size_t orig_num, size_t num) {
	if(orig_num >= num)
		return orig_array;
	
	T *new_array = new T[num];
	if(orig_num > 0)
		memcpy((void *)new_array, (void *)orig_array, orig_num * sizeof(T));
	if(orig_array!=NULL)
		delete[] orig_array;
	return new_array;
}

void update_url(char **packages_filename, char *url, char *url_prefix) {
	
	mkdir_p(LISTS_DIR, 0755);
	
	get_file(url, packages_filename, true, true);
	
}

//bool parse_conffile(char *conffile_name, char ***urls, char ***prefixes, int *num) {
namespace media {
	bool parse_conffile(char *conffile_name, char ***packages_filenames, char ***prefixes, int *packages_file_count);
	bool add_to_list(char ***str_list, int count, char *new_str);
	char *read_line(FILE *conffile);
//	char *url2local_filename(char *url);
};
/*
char *media::url2local_filename(char *url) {
	int len = strlen(url) + 1;
	char *local_file = new char[len];
	int i, j;
	for(i=0, j=0; i<len; i++) {
		local_file[i] = (url[j] == ':' || url[j] == '/') ? '_' : url[j];
		if(url[j]==':' || url[j] == '/')
			while(url[j]==':' || url[j] == '/') j++;
		else
			j++;
	}
	local_file[i] = '\0';
	return local_file;
}
*/
char *media::read_line(FILE *conffile) {
	char *out = new char[1024];
	int len=0;
	do {
		if((len & 1023) == 1023)
			out = myrealloc<char>(out, len, len+1025);
		out[len] = fgetc(conffile);
	} while(out[len++] != '\n' && !feof(conffile));
	out[len-1] = '\0';
	return out;
}

bool media::parse_conffile(char *conffile_name, char ***packages_urls, char ***prefixes, int *packages_file_count) {
	FILE *conffile = fopen(conffile_name, "r");
	if(conffile == NULL) {
		fprintf(stderr, "parse_conffile.cpp: parse_conffile(): 73: ");
		perror(conffile_name);
		return false;
	}
	enum {DEBIAN_MODE, UHU_MODE} mode;
	int line_count = 0;
	while (!feof(conffile)) {
		char *line = read_line(conffile);
		line_count++;
		int i=0;
		while(line[i] == ' ' || line[i] == '\t') i++;
		if(line[i] == '#' || line[i] == '\0') {
			delete[] line;
			continue;
		}
		if(strncmp(line+i, "deb", 3) != 0) {
			fprintf(stderr, "parse error in '%s' at line %d\n", conffile_name, line_count);
			delete[] line;
			continue;
		} else
			i+=3;
		if(line[i] != ' ' && line[i] != '\t') {
			//maybe "deb-src"
			delete[] line;
			continue;
		}
		while(line[i] == ' ' || line[i] == '\t') i++;
		int j;
		for(j = i; line[j] != ' ' && line[j] != '\t' && line[j] != '\0'; j++);
		
		
		int line_end = strlen(line) - 1;
		while((line[line_end] == ' ' || line[line_end] == '\t') && line_end>0) line_end--;
		if(line[line_end] == '/')
			mode = UHU_MODE;
		else
			mode = DEBIAN_MODE;
		
		
		char *prefix = new char[line_end];
		strncpy(prefix, line+i, j - i);
		prefix[j-i]='\0';
		//printf("parse_conffile.cpp: parse_conffile(): 113: prefix = [%s]\n", line);
		char *url = new char[line_end + 10];
		
		if(mode == UHU_MODE) {
			int k;
			for(j=i, k=0; j<=line_end; k++) {
				if(line[j] == ' ' || line[j] == '\t') {
					url[k] = '/';
					while(line[j] == ' ' || line[j] == '\t') j++;
				} else {
					url[k] = line[j];
					j++;
				}
			}
			url[k] = '\0';
			sprintf(url+k, "/Packages");
			add_to_list(packages_urls, *packages_file_count, url);
			add_to_list(prefixes, *packages_file_count, prefix);
			//fprintf(stderr, "%s:%d: prefix=%s\n",__FILE__,__LINE__,prefix);
			(*packages_file_count)++;
		} else {/*DEBIAN_MODE*/
			fprintf(stderr, "Sorry, it isn't implemented...");
			delete[] line;
			delete[] url;
			delete[] prefix;
			return false;
		}
		
		
		delete[] line;
	}
	return true;
}
/*
bool media::parse_conffile(char *conffile_name, char ***packages_filenames, char ***prefixes, int *packages_file_count) {
	char c;
	char *prefix;
	int packages_filename_mem;
	char *url;
	int url_len = 0;
	int i;
	int offset = 0;
	int mode = 0; / *mode 1: There is a '/' character at the end of the second word in
			the config file (sources.list)
			mode 0: There isn't. (you have to enter to some directories
			eg "dists", etc.)* /

	FILE *conffile = fopen(conffile_name, "r");
	if(conffile == NULL) {
		perror(conffile_name);
		return false;
	}
	
	url = new char[1024];
	
	printf("olvasom: [%s]\n", conffile_name);
	while(!feof(conffile)) {
		
		do {
			c = fgetc(conffile);
		} while(c == ' ' || c == '\t');
		if(c == '#') {
			do {
				c = fgetc(conffile);
			} while(c != '\n' && !feof(conffile));
			continue;
		}
		if(feof(conffile))
			break;
		if(c=='\n')
			continue;
		for(i=0; i<4; i++) {
			url[i] = c;
			c = fgetc(conffile);
			if(c=='\n' || feof(conffile)) {
				url[0] = '\0';
				break;
			}
		}
		if(c =='\n')
			continue;
			/ *ha rovidebb 4-nel a sor* /
		
		if(feof(conffile))
			break;
		if(strncmp(url, "deb", 3) || (url[3] != ' ' && url[3] != '\t')) {
			while(c != '\n' && !feof(conffile)) c = fgetc(conffile);
			continue;
		}
		if(feof(conffile))
			break;
		
		while(c == ' ' || c == '\t') c = fgetc(conffile);

		while(c!=' ' && c != '\t' && c!='\n' && !feof(conffile)) {
			if((url_len & 1023) == 1023)
				url = myrealloc<char>(url, url_len, url_len+1025);
			url[url_len++] = c;
			c = fgetc(conffile);
		}
		url[url_len] = '\0';
		
		if(url[url_len - 1] == '/') {
			mode = 1;
			while(c != '\n' && !feof(conffile)) {
				while(c == ' ' || c == '\t') c = fgetc(conffile);
				if((url_len & 1023) == 1023)
					url = myrealloc<char>(url, url_len, url_len+1025);
				if(c!=' ' && c!='\t' && c!='\n' && !feof(conffile)) {
					url[url_len++] = c;
					c = fgetc(conffile);
				}
			}
		} else
			mode = 0;
		
		if(url[url_len - 1] != '/') {
			if((url_len & 1023) == 1023)
				url = myrealloc<char>(url, url_len, url_len+1025);
			url[url_len++] = '/';
		}
		url[url_len] = '\0';

		i = url_len + strlen(LISTS_DIR) + 30;
		
		if(!strncmp(url, "http://", 7))
			offset=7;
		else if(!strncmp(url, "ftp://", 6))
			offset=6;
		else {
			fprintf(stderr, "WARNING: unknown media: \n\tdeb %s\n", url);
			if(url_len >= 1023) {
				delete[] url;
				url = new char[1024];
			}
			continue;
		}
		if(mode == 1) {
			add_p_file_to_list(packages_filenames, prefixes, *packages_file_count, url, prefix);
			(*packages_file_count)++;
		} else {
			int split;
			i = url_len - offset + strlen(LISTS_DIR) + 6  / *strlen("dists/")* /;
			
			while(c == ' ' || c == '\t') c = fgetc(conffile);
			
			while(c!=' ' && c != '\t' && c!='\n' && !feof(conffile)) {
				c = fgetc(conffile);
			}
			split = i;
			while(c!='\n' && !feof(conffile)) {
				i = split;
				
				while(c == ' ' || c == '\t') c = fgetc(conffile);
				
				while(c!=' ' && c != '\t' && c!='\n' && !feof(conffile)) {
					c = fgetc(conffile);
				}
				if(i == split)
					break;
//				printf("FILE: %s URL: %s\n", packages_filename, url);
//				read_file(packages_filename, url);
				//printf("mode 0\npackages_filename = [%s]\nurl = [%s]\n", packages_filename, url);
				add_p_file_to_list(packages_filenames, prefixes, *packages_file_count,
						url, );
				(*packages_file_count)++;
				//XXX: oda nem az url-t kell irni
			}
		}
			
		
		if(url_len >= 1023) {
			delete[] url;
			url = new char[1024];
		}
		if(packages_filename_mem >= 1023) {
			delete[] packages_filename;
			packages_filename = new char[1024];
		}
		url_len = 0;
	}
	return true;
}
*/
bool media::add_to_list(char ***str_list, int count, char *new_str) {
	*str_list = myrealloc<char *>(*str_list, count, count+1);
	*str_list[count] = new_str;
	return true;
}

bool media::update(char *conffile_name, abpmString destdir) {
	char **packages_urls=NULL;
	char **prefixes=NULL;
	char **local_filenames=NULL;
	int packages_file_count=0;
	bool retval;
	
	retval = parse_conffile(conffile_name, &packages_urls, &prefixes, &packages_file_count);
	
	
	
//	printf("parse_conffile.cpp: update(): 313: Packages file-ok: %d\n", packages_file_count);
	local_filenames = new char*[packages_file_count];
	for(int i=0; i<packages_file_count; i++) {
		update_url(&(local_filenames[i]), packages_urls[i], prefixes[i]);
//		printf("parse_conffile.cpp: update(): 317: |%s|  |%s|\n", packages_urls[i], local_filenames[i]);
	}
	database::create_available_db(database::GENERATE, local_filenames, prefixes, packages_file_count, destdir);
//	printf("parse_conffile.cpp: update(): 320: return%d\n", retval);
	
	return retval;
}

