/* vi: set ts=4 sw=4: */
#include <stdio.h>
#include <sqlite.h>
#include <string.h>
#include <fcntl.h>
#include <stdlib.h>

#include "abpm_types.h"
#include "package.h"
#include "iface.h"

namespace media {

	class Url_finder {
		private:
			char *error;
			sqlite *mydb;
			char **results;
			int result_count;

			void free_results();
		public:
			//static int _sqliteCallback(void *pArg, int argc, char **argv, char **columnNames);
			int _add_to_results(char *result);

			//bool find_urls(char *filename, char *version);
			bool find_urls(char *filename, char *version, abpmString destdir);
			/* Search all url-s from database where "filename" file
			 * can be found, and stores results in "results"
			 * variable.
			 * Returns false if it doesn't find anything,
			 * othervise true.*/

			inline char **get_results(int *count) {*count = result_count; return results;}

			Url_finder();
			~Url_finder();
	};

	Url_finder::Url_finder() {
		mydb = NULL;
		error = NULL;
		results = NULL;
		result_count = 0;
	}

	Url_finder::~Url_finder() {
		free_results();
	}

	void Url_finder::free_results() {
		for (int i=0; i<result_count; i++)
			delete[] results[i];
		delete[] results;
		results = NULL;
		result_count = 0;
	}	

	int Url_finder::_add_to_results(char *url) {
		//XXX: a c++-ban nincs "realloc"-nak megfelelo funkcio???????
		char **tmp = new char*[result_count + 1];
		for (int i=0; i<result_count; i++)
			tmp[i] = results[i];
		tmp[result_count] = new char[strlen(url) + 1];
		strcpy(tmp[result_count], url);
		if(result_count != 0)
			delete[] results;
		results = tmp;
		result_count++;

		return 0;
	}
/*
	int Url_finder::_sqliteCallback(void *pArg, int argc, char **argv, char **columnNames) {
		Url_finder *url_finder = (Url_finder *)pArg;
		return url_finder->_add_to_results(argv[0]);
	}
*/

/*	bool Url_finder::find_urls(char *filename, char *version, abpmString destdir) {
		if(result_count > 0)
			free_results();

		char *command = new char[strlen(filename) + strlen(version) + 200];

		sprintf(command, "SELECT filename FROM details WHERE name = '%s' AND version = '%s'",
				filename, version);
		//	printf("Command : %s\n", command);
		mydb = sqlite_open(destdir + ABPM_AVAILABLE_DB_FILE, O_RDONLY, &error);
		if(mydb==NULL) {
			fprintf(stderr, "%s\n", error);
			exit(1);
		}

		if(sqlite_exec(mydb, command, Url_finder::_sqliteCallback, this, &error)) {
			fprintf(stderr, "%s\n", error);
			fprintf(stderr, "command: %s\n", command);
		}

		delete[] command;
		sqlite_close(mydb);
		//if(result_count>0)
		//	fprintf(stderr, "%s: %d: result[0]: %s\n",__FILE__,__LINE__,results[0]);
		return result_count > 0;
	}
*/
	bool get_package(abpmString &pkg_name, Version_iface *pkg_version, char **local_filename, abpmString &destdir) {
		//Url_finder finder;
		//finder.find_urls(pkg_name, pkg_version->getstring(), destdir);
		//urls = finder.get_results(&url_count);

		bool retval = false;
		Package pkg(pkg_name, pkg_version);
		abpmVector<abpmString> urls = database::find_urls(&pkg, destdir);

		for(int i=0; i<urls.size() && retval == false; i++) {
			//_debuginfo("get_file jon\n");
			//printf("%s: %d: urls[i] = [%s] (url_count = %d\n", __FILE__, __LINE__, urls[i], url_count);
			retval = get_file(urls[i], local_filename, false, false);
			//_debuginfo("get_file vege\n");
		}
		//_debuginfo("get_package vege\n");
		return retval;
	}
};
