#include <sys/stat.h>
#include <sys/types.h>
#include "abpmBasePackageFile.h"
#include "abpmString.h"
#include "utils.h"
//#include "debug.h"

bool abpmBasePackageFile::copy_scripts(abpmString destdir) {
	abpmString scriptdir = destdir + ABPM_SCRIPTDIR;
	abpmString scriptbase = scriptdir + "/" + name;
	abpmString script_data;
	
	abpmString script_name = scriptbase + "_preinst.sh";
	script_data = get_preinst_script();
	mkdir_p(scriptdir, 0755);
	FILE *script = fopen(script_name, "w");
	fprintf(script, "%s", (char *)script_data);
	fclose(script);
	chmod(script_name, 0755);
	
	script_name = scriptbase + "_postinst.sh";
	script_data = get_postinst_script();
	script = fopen(script_name, "w");
	fprintf(script, "%s", (char *)script_data);
	fclose(script);
	chmod(script_name, 0755);
	
	script_name = scriptbase + "_prerm.sh";
	script_data = get_prerm_script();
	script = fopen(script_name, "w");
	fprintf(script, "%s", (char *)script_data);
	fclose(script);
	chmod(script_name, 0755);
	
	script_name = scriptbase + "_postrm.sh";
	script_data = get_postrm_script();
	script = fopen(script_name, "w");
	fprintf(script, "%s", (char *)script_data);
	fclose(script);
	chmod(script_name, 0755);

	install_additional_files(destdir);
	//TODO: es ha nincs script????
}	
bool abpmBasePackageFile::unpack(abpmString destdir) {
	while(next_file()) {
		abpmString rfilename = cur_distfile_name();
		abpmString filename = destdir + "/" + rfilename;
		distfile_type cur_type = cur_distfile_type();
		if(cur_type==CONFIG && is_file(filename)) {
			filename += ".abpm_new";
			fprintf(stderr, "%s: %d: conffile name = %s\n", __FILE__,__LINE__,(char *)filename);
		}
		copy_file(filename, destdir);
	}
	return true;
}
