#ifndef __ABPM_BASE_PACKAGE_FILE_H
#define __ABPM_BASE_PACKAGE_FILE_H

#include "ph_types.h"
#include "abpmPackageFile.h"
#include "abpmVirtualFile.h"
#include "abpmString.h"

class abpmBasePackageFile : public abpmVirtualFile, public virtual abpmPackageFile{
	protected:
		abpmString name;
		enum distfile_type {NORMAL,CONFIG};
		virtual distfile_type cur_distfile_type()=0;
		virtual bool next_file()=0;
		virtual bool copy_file(abpmString path, abpmString prefix_dir)=0;
		virtual abpmString cur_distfile_name()=0;
		virtual abpmString get_preinst_script()=0;
		virtual abpmString get_postinst_script()=0;
		virtual abpmString get_prerm_script()=0;
		virtual abpmString get_postrm_script()=0;
		virtual bool install_additional_files(abpmString destdir) {return true;}
		abpmString base_filename(abpmString s) {return abpmVirtualFile::base_filename(s);}
	public:
		virtual bool copy_scripts(abpmString destdir);
		virtual bool unpack(abpmString destdir);
		virtual ssize_t read(void *buf, size_t maxlen) {return abpmVirtualFile::read(buf,maxlen);}
		virtual off_t seek(off_t offset, int whence) {return abpmVirtualFile::seek(offset,whence);}
		virtual int getchar() {return abpmVirtualFile::getchar();}
		virtual bool eof() {return abpmVirtualFile::eof();}
		//virtual abpmVector<abpmString> conf_files()=0;
		
};

#endif
