#ifndef __ABPM_CPIO_FILE_H
#define __ABPM_CPIO_FILE_H

//#include "abpm_zlib.h"
#include "ph_types.h"
#include "abpmVirtualFile.h"
#include "abpmDirectory.h"
#include <unistd.h>

struct cpio_hdr;

class abpmCpioFile : public abpmVirtualFile, public abpmDirectory  {
	private:
		off_t start;
		off_t end;
		bool file_choosen;
		enum {ASC, BIN, NEW, NEWCRC, UNKNOWN} type;
		void find_type();
		//bool next_header(cpio_hdr *buf);
		
		bool readbinheader(cpio_hdr *buf);
		bool readascheader(cpio_hdr *buf);
		bool readnewheader(cpio_hdr *buf);
		bool readheader(cpio_hdr *buf);
		int readshort(u_int16_t *buf) {return readbytes((char *)buf, sizeof(u_int16_t));}
	public:
		abpmVector<abpmString> list();
		abpmFile *choose_file(abpmString s);
		bool is_file(abpmString path);
		ssize_t read(void *out_buf, size_t maxlen);
		off_t seek(off_t offset, int whence);
		bool eof();
		abpmCpioFile(abpmString filename, bool useraw=false);
		abpmCpioFile(abpmFile *raw_reader, bool useraw=false);

		bool unpack(abpmString destdir);
};

#endif
