#ifndef __ABPM_DEB_FILE_H
#define __ABPM_DEB_FILE_H

#include "abpm_types.h"
#include "iface.h"
#include "ph_types.h"
#include "abpmBasePackageFile.h"


class abpmDebFile : public abpmBasePackageFile {
	private:
		abpmArFile *pkg;
		abpmTGZFile *control;
		abpmTGZFile *data;
		abpmVector<abpmString> conffiles;
		package_control_info pkg_cntl_info;
		distfile_type cur_type;
		void checkdata();
		void checkcontrol();
		abpmString file2str(abpmFile *f);
		void create();
		physical_package_info *info;
	protected:
		//abpmString name;
		//enum distfile_type {NORMAL,CONFIG};
		distfile_type cur_distfile_type();
		bool next_file();
		bool copy_file(abpmString path, abpmString prefix_dir);
		abpmString cur_distfile_name();
		abpmString get_preinst_script();
		abpmString get_postinst_script();
		abpmString get_prerm_script();
		abpmString get_postrm_script();
		bool install_additional_files(abpmString destdir);
	public:
		bool get_physical_info(physical_package_info *info);
                bool get_package_info(package_control_info *info);
		//virtual abpmVector<abpmString> conf_files()=0;
		abpmDebFile(abpmFile *rawfile, bool useraw=false);
		//bool get_real_physical_info(physical_package_info *info);
		abpmDebFile(abpmString path, bool useraw=false);
		abpmVector<abpmString> list();
		abpmFile *choose_file(abpmString filename);
		bool is_file(abpmString filename);
		abpmVector<abpmString> conf_files();
		virtual ~abpmDebFile();
};

#endif
