#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <fcntl.h>
#include <string.h>
#include <stdio.h>
#include "abpmRawFile.h"
#include "abpmString.h"

inline ssize_t myread(int fd, void *buf, size_t count) {
	return read(fd, buf, count);
}
ssize_t abpmRawFile::read(void *out_buf, size_t maxlen) {
	/*if(fd<0)
		return 0;
	ssize_t retval = myread(fd, out_buf, maxlen);
	if(retval<=0)
		_eof=true;
	return retval;*/
	if(fp==NULL)
		return -1;
	return fread(out_buf, 1, maxlen, fp);
}

off_t abpmRawFile::seek(off_t offset, int whence) {
	/*if(fd<0)
		return 0;
	_eof=false;
	
	off_t retval = lseek(fd, offset, whence);
	return retval;*/
	
	if(fp==NULL)
		return -1;
	int result = fseek(fp, offset, whence);
	if(result < 0) {
		perror("seek");
		return result;
	}
	off_t retval = ftell(fp);
	return retval;
	
}

int abpmRawFile::getchar() {
	/*if(fd<0)
		return EOF;
	char c;
	if(read(&c, 1)<=0) {
		_eof=true;
		return EOF;
	}
	return c;*/
	if(fp==NULL)
		return EOF;
	return fgetc(fp);
}

bool abpmRawFile::eof() {
	/*if(fd<0)
		return true;
	return _eof;*/
	if(fp==NULL)
		return true;
	return feof(fp);
}

abpmRawFile::abpmRawFile(abpmString filename) {
	/*fd = open(filename, O_RDONLY | O_NOATIME);
	if(fd < 0) {
		perror(filename);
		return;
	}
	_eof=false;*/
	fp=fopen(filename, "rb");
	if(fp==NULL)
		perror(filename);
}

abpmRawFile::~abpmRawFile() {
	/*if(fd>=0)
		close(fd);*/
	if(fp!=NULL)
		fclose(fp);
}

