#ifndef __ABPM_RPM_FILE_H
#define __ABPM_RPM_FILE_H

//#include "abpm_zlib.h"
#include "ph_types.h"
#include "abpmVirtualFile.h"
#include "abpmDirectory.h"
#include <unistd.h>
#include <sys/types.h>


struct rpmlead;
struct rpmsign_hd;

#define SIGN_START 96

class abpmRpmFile : public abpmVirtualFile, public abpmDirectory  {
	private:
		rpmlead *_lead;
		off_t header_start;
		off_t start;
		off_t end;
		bool header_read;
		
		bool readlead();
		bool readuint32(u_int32_t *buf);
		bool readsignheader(rpmsign_hd *);
		bool skipsign();
		bool checksign() {return true;} /*TODO...*/
	public:
		void gotodata();
		void printresidoom();
		
		abpmVector<abpmString> list();
		abpmFile *choose_file(abpmString s);
		bool is_file(abpmString path);
		ssize_t read(void *out_buf, size_t maxlen);
		off_t seek(off_t offset, int whence);
		bool eof();
		abpmRpmFile(abpmString filename, bool useraw=false);
		abpmRpmFile(abpmFile *raw_reader, bool useraw=false);
		virtual ~abpmRpmFile();

		bool unpack(abpmString destdir);
};

#endif
