#ifndef __ABPM_TGZ_FILE_H
#define __ABPM_TGZ_FILE_H

//#include "abpm_zlib.h"
#include "ph_types.h"
#include "abpmVirtualFile.h"
#include "abpmDirectory.h"
#include "abpmTarFile.h"


class abpmTGZFile : public abpmVirtualFile, public abpmDirectory  {
	private:
		abpmTarFile *tarfile;
	public:
		abpmVector<abpmString> list();
		abpmFile *choose_file(abpmString s);
		bool is_file(abpmString path);
		ssize_t read(void *out_buf, size_t maxlen);
		off_t seek(off_t offset, int whence);
		bool unpack(abpmString destdir);
		bool next_file() {return tarfile->next_file();}
		bool copy_file(abpmString path, abpmString prefix_dir) {return tarfile->copy_file(path, prefix_dir);}
		abpmString cur_distfile_name() {return tarfile->cur_distfile_name();}
		abpmTGZFile(abpmString filename, bool useraw=false);
		abpmTGZFile(abpmFile *raw_reader, bool useraw=false);
		abpmTGZFile(abpmFile *raw_reader, abpmString subfile_path, bool useraw=false);
};

#endif
