/* vi: set ts=4 sw=4: */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "abpm_types.h"
#include "abpmFile.h"
#include "abpmVirtualFile.h"
#include "iface.h"
#include "item.h"
#include "names.h"
#include "deb_db_parse.h"

//#include "debug.h"

/* It puts the read data intto the Item structure.
 * it returns 1 on the end of the section (empty data string),
 * -1 if the status is "not installed", otherwize 0. */
int physical::control_parseline(char **item, char *data, abpmFile *deb_control_file_fr) {
	int i;
	unsigned int len, l;
	char c;
	
	//fprintf(stderr,"%s: %d: control_parseline indul\n", __FILE__,__LINE__);
	if(!strcmp(data, "")) {
//		if(deb_control_file_fr->eof() && strlen(item[PKG_NAME]) == 0)
		if(strlen(item[PKG_NAME]) == 0)
			return -1;
		else {
	//		printf("strlen(item[PKG_NAME])=%d item[PKG_NAME]=[%s]\n", strlen(item[PKG_NAME]), item[PKG_NAME]);
			return 1;
		}
	}
	
	len = strlen(data);
	
	l = 7; /*strlen("Status:")*/ 
	if(!strncmp(data, "Status:", l)) {
		while(data[l] == ' ' || data[l] == '\t') ++l;
		if(strcmp(data + l, "install ok installed"))
			return -1;
		else
			return 0;
		/*TODO: not perfect installations...*/
	}
	
	
	for(i=0; i<PKG_SHORT_DESC; i++) {
		l=strlen(Entry_name[i]);
		if(strncmp(data, Entry_name[i], l) == 0) {
			if(strcmp(item[i], "") != 0) {
				fprintf(stderr, "parse error: in package near \"%s\", "
						"there ar more then one \"%s\" line.\n",
						item[PKG_NAME], Entry_name[i]);
				exit(1);
			}
			//if(i==PKG_NAME)
			//	_debuginfo(data);
			//if(i==PKG_FILENAME)
				//fprintf(stderr, "%s: %d: data=%s\n",__FILE__,__LINE__,data);
			if(len > 1024 + l) {
				free(item[i]);
				item[i] = (char *)malloc(len - l);
			}
			/*FIXME: es az ellenorzes?*/

			while(data[l] == ' ' || data[l] == '\t') ++l;
			sprintf(item[i], "%s", data + l);
		}
	}
	
	l = strlen(Entry_name[PKG_SHORT_DESC]);
	if(strncmp(data, Entry_name[PKG_SHORT_DESC], l) == 0) {
		if(strcmp(item[PKG_SHORT_DESC], "") != 0) {
			fprintf(stderr, "parse error: that package near \"%s\""
					"has more then one description?!\n", item[PKG_NAME]);
			exit(1);
		}
		if(len > 1024 + l) {
			free(item[PKG_SHORT_DESC]);
			item[PKG_SHORT_DESC] = (char *)malloc( len - l);
		}
		/*FIXME: es az ellenorzes?*/
		
		while(data[l] == ' ' || data[l] == '\t') ++l;
		sprintf(item[PKG_SHORT_DESC], "%s", data + l);
		len = 0;

		free(item[PKG_LONG_DESC]);
		item[PKG_LONG_DESC] = (char *)malloc(1024);
		while(1) {
			//pos = ftell(packages);
			c = deb_control_file_fr->getchar();
			if(c != ' ') {
				deb_control_file_fr->seek(-1, SEEK_CUR);
				break;
			}
			
			do {
				if((len & 1023) == 1023)
					item[PKG_LONG_DESC] = (char *)realloc((void *)(item[PKG_LONG_DESC]), len + 1025);
				/*FIXME: es az ellenorzes?*/
				
				item[PKG_LONG_DESC][len] = deb_control_file_fr->getchar();
				if(item[PKG_LONG_DESC][len] == '\'') {
//					printf("' karakter van, de megoldottam\n");
					if(((++len) & 1023) == 1023)
						item[PKG_LONG_DESC] = (char *)realloc((void *)(item[PKG_LONG_DESC]), len + 1025);
						//FIXME: es az ellenorzes?
//					item[LONG_DESC][len] = item[LONG_DESC][len-1];
					item[PKG_LONG_DESC][len] = '\'';
//					item[LONG_DESC][len] = '?';
				}
			} while(item[PKG_LONG_DESC][len++]!='\n' && !deb_control_file_fr->eof());
		}
		if(len > 0)
			item[PKG_LONG_DESC][len-1] = '\0';
		else
			item[PKG_LONG_DESC][0] = '\0';
	}
	return 0;
}


void physical::read_control_db(abpmFile *deb_control_file_fr, package_control_info **info, int *package_num) {
	//char **result;
	//int nrow, ncolumn;
	char *data;
	unsigned int i;
	int result;
	char **items;
	int need_this_package = 1;
	
//	int need_to_write = 1;
	
	data = (char *)malloc(1024);
	
	*package_num = 0;
	*info = NULL;
	items = new_item();
	zero_item(items);
	
	
	while(!deb_control_file_fr->eof()) {
		i=0;
		do {
			if((i & 1023) == 1023)
				data = (char *)realloc((void *)data, i+1025);
				/*FIXME: Es az ellenorzes????*/
			
			data[i] = deb_control_file_fr->getchar();
			
			if(data[i] == '\'') {
				if(((++i) & 1023) == 1023)
					data = (char *)realloc((void *)data, i+1025);
					/*FIXME: Es az ellenorzes????*/
			
				data[i] = '\'';
			}
		} while(data[i++] != '\n' && !deb_control_file_fr->eof());
//		printf("read_tontrol_file() sorveg\n");
		data[i-1] = '\0';
		
		result = control_parseline(items, data, deb_control_file_fr);
		
		if(result<0) {
			need_this_package = 0;
		}
//		if(result != 0)
//			printf(" physical/deb_db_parse.cpp:160 result = %d name = %s\n", result, items[PKG_NAME]);
		if(result > 0 || deb_control_file_fr->eof()) {
			if(need_this_package) {
				if((*package_num & 0x3ff) == 0) {
					*info = (package_control_info *)realloc((void *)(*info), (*package_num + 0x400) * sizeof(package_control_info));
					for(int j = *package_num + 1; j < *package_num + 0x400; j++)
						(*info)[j].items = NULL;
				}
				//printf(" physical/deb_db_parse.cpp:168 package beirva: [%s] (%d)\n", items[PKG_NAME], items[PKG_NAME][0]);
				(*info)[*package_num].items = items;
				(*package_num)++;
			} else {
				//free_item(items);
				need_this_package = 1;
			}
			
			items = new_item();
			zero_item(items);
//			printf("adat vege...\n");
		}
		if(i >= 1023) {
			free(data);
			data = (char *)malloc(1024);
		}
	}
}

void physical::deb_read_old_available_db(abpmString &db_path, package_control_info **info, int *num) {
	abpmFile *fr;
	
	fr = new abpmVirtualFile(db_path);
	
	read_control_db(fr, info, num);
	delete fr;
}

