#ifndef __PHYSICAL_IFACE_H
#define __PHYSICAL_IFACE_H
#include <sys/types.h>
#include "abpm_types.h"
#include "ph_types.h"
#include "abpmVector.h"
#include "abpmTarFile.h"

/*typedef enum {
	OWNER_ID = 0,
	OWNER,
	GROUP_ID,
	GROUP,
	TYPE,
	MODE,
	MAJOR,
	MINOR,
	SIZE,
	TIME,
	MD5,
	NAME
} PHYSICAL_CNTL_INFO_TYPE;


typedef struct {
	char *filename;
	
	uid_t owner_id;
	char *owner;
	gid_t group_id;
	char *group;
	char type;
	mode_t mode;
	int major;
	int minor;
	size_t size;
	time_t time;
	char *md5;
	u_int32_t flags;
	
	int uid_used;
	int gid_used;
	int type_used;
	int mode_used;
	int major_used;
	int minor_used;
	int size_used;
	int time_used;
	int flags_used;
} physical_file_info;


typedef struct {
	char **items;
} package_control_info;

*/

namespace physical {
	enum {
		BUILDINFO,
		CONTROL,
		MD5SUMS,
		POSTINST,
		POSTRM,
		PRERM,
		STAT,
		CNTL_FILE_COUNT
	};
	extern const char *control_files[];
	
	//internal
	void deb_get_info(int info_type, physical_package_info *info, abpmFile *fr);
	
	int deb_get_physical_info(char *pkg_filename, physical_package_info *info);
	int deb_get_package_info(char *pkg_filename, package_control_info *info);
	//int deb_unpack(char *pkg_filename, char *prefix_dir);
	int remove(physical_package_info *info, char *prefix_dir);

	void read_old_available_db(char *old_db_filename, package_control_info **info, int *pkg_num);
};

/*
class physical_iface {
	public:
		virtual bool install_package(char *path)=0;
		virtual physical_package_info get_info(char *path)=0;
		virtual bool update()=0;
};
*/

#endif
