/* vi: set ts=4 sw=4: */
#include "version.h"
#include <stdio.h>
#include <string.h>

int Version::_subsubver_cmp(const char *ver1, const char *ver2) {
//	char *buf1 = new char[strlen(ver1) + 1];
//	char *buf1 = new char[strlen(ver2) + 1];
	int i1 = 0;
	int b1;
	int i2 = 0;
	int b2;
	int s1, s2;
	
	
//	printf("_subsubver_cmp: %s %s\n", ver1, ver2);
	do {
		b1 = i1;
		while(ver1[i1] >='0' && ver1[i1] <='9')
			i1++;
		b2 = i2;
		while(ver2[i2] >='0' && ver2[i2] <='9')
			i2++;
		if(i1!=b1) {
			sscanf(ver1 + b1, "%d", &s1);
			if(i2 == b2)
				return 1;
		}
		if(i2!=b2) {
			sscanf(ver2 + b2, "%d", &s2);
			if(i1 == b1)
				return -1;
		}
		
		if(i1 != b1 && i2 != b2) {
			if(s1 < s2)
				return -1;
			if(s1 > s2)
				return 1;
		}
		
		while(ver1[i1] == ver2[i2] && ver1[i1] != '\0' && ver2[i2] != '\0' &&
				(ver1[i1] < '0' || ver1[i1] > '9') &&
				(ver2[i2] < '0' || ver2[i2] > '9')) {
			i1++;
			i2++;
		}
		if((ver1[i1] < '0' || ver1[i1] > '9') ||
				(ver2[i2] < '0' || ver2[i2] > '9')) {
			if(ver1[i1] == '~')
				return -1;
			if(ver2[i2] == '~')
				return 1;
			if(ver1[i1] == '\0' && ver2[i2] == '\0')
				return 0;
			if(ver1[i1] == '\0')
				return -1;
			if(ver2[i2] == '\0')
				return 1;
			return ver1[i1] < ver2[i2] ? -1 : 1;
		}
	} while(ver1[i1] !='\0' && ver2[i2] != '\0');
	return 0;
}



int Version::_subver_cmp(const char *ver1, const char *ver2) {
	int i1 = 0;
	int b1;
	int i2 = 0;
	int b2;
	int chk;

	char buf1[strlen(ver1) + 1];
	char buf2[strlen(ver2) + 1];
	
	
	if(ver1[i1] == '\0' || ver2[i2] == '\0')
		return 0;
	do {
		b1 = i1;
		while(ver1[i1] != '.' && ver1[i1] != '\0') {
			buf1[i1 - b1] = ver1[i1];
			i1++;
		}
		buf1[i1 - b1] = '\0';
		b2 = i2;
		while(ver2[i2] != '.' && ver2[i2] != '\0') {
			buf2[i2 - b2] = ver2[i2];
			i2++;
		}
		buf2[i2 - b2] = '\0';
		chk = _subsubver_cmp(buf1, buf2);
		//printf("%s:%d:%s es %s viszonya: %d\n", __FILE__,__LINE__,ver1, ver2, chk);
		if(chk != 0) {
			return chk;
		}
		if(ver1[i1] != '\0')
			i1++;
		if(ver2[i2] != '\0')
			i2++;
	} while (ver1[i1] != '\0' || ver2[i2] != '\0');
	return 0;
}

int Version::version_cmp(const char *ver1, const char *ver2) {
	int i1 = 0;
	int b1;
	int i2 = 0;
	int b2;
	int chk;
	
	//printf("%s:%d:_subver_cmp: %s,%s\n", __FILE__,__LINE__,ver1, ver2);
	if(ver1[0] == '\0' || ver2[0] == '\0')
		return 0;
	
	char buf1[strlen(ver1) + 1];
	char buf2[strlen(ver2) + 1];
	
	while(ver1[i1] ==' ' || ver1[i1] == '\t')
		i1++;
	while(ver2[i2] ==' ' || ver2[i2] == '\t')
		i2++;
	do {
		//printf("%s:%d:_subver_cmp: %s,%s\n", __FILE__,__LINE__,ver1, ver2);
		b1 = i1;
		while(ver1[i1] != '-' && ver1[i1] != ':' && ver1[i1] != '\0') {
			buf1[i1 - b1] = ver1[i1];
			i1++;
		}
		buf1[i1 - b1] = '\0';
		
		b2 = i2;
		while(ver2[i2] != '-' && ver2[i2] != ':' && ver2[i2] != '\0') {
			buf2[i2 - b2] = ver2[i2];
			i2++;
		}
		buf2[i2 - b2] = '\0';

		if(ver1[i1] == ':' && ver2[i2] != ':')
			return 1;
		if(ver2[i2] == ':' && ver1[i1] != ':')
			return -1;
		
		chk = _subver_cmp(buf1, buf2);
		//printf("%s:%d:_subver_cmp: %s es %s viszonya: %d\n", __FILE__,__LINE__,ver1, ver2, chk);
		if(chk != 0) {
		//	printf("%s:%d:_subver_cmp: %s es %s viszonya: %d\n", __FILE__,__LINE__,ver1, ver2, chk);
			return chk;
		}
		if(ver1[i1] == '-' && ver2[i2] != '-')
			return 1;
		if(ver2[i2] == '-' && ver1[i1] != '-')
			return -1;
		if(ver1[i1] == '-' || ver1[i1] == ':')
			i1++;
		if(ver2[i2] == '-' || ver2[i2] == ':')
			i2++;
	} while(ver1[i1] != '\0' || ver2[i2] != '\0');
	return 0;
}

bool Version::_dep_ver_chk(const char *ver, const char *ver_shema) {
	int i=0;
	
	if(!strcmp(ver, ""))
		return false;
	
	while(ver_shema[i] == ' ' || ver_shema[i] == '\t')
		i++;
	if(ver_shema[i] == '\0')
		return true;
	if(!strncmp("<<", ver_shema + i, 2)) {
		i+=2;
		while(ver_shema[i] == ' ' || ver_shema[i] == '\t')
			i++;
		return version_cmp(ver, ver_shema + i) < 0;
	}
	if(!strncmp(">>", ver_shema + i, 2)) {
		i+=2;
		while(ver_shema[i] == ' ' || ver_shema[i] == '\t')
			i++;
		return version_cmp(ver, ver_shema + i) > 0;
	}
	if(!strncmp(">=", ver_shema + i, 2)) {
		i+=2;
		while(ver_shema[i] == ' ' || ver_shema[i] == '\t')
			i++;
		return version_cmp(ver, ver_shema + i) >= 0;
	}
	if(!strncmp("<=", ver_shema + i, 2)) {
		i+=2;
		while(ver_shema[i] == ' ' || ver_shema[i] == '\t')
			i++;
		return version_cmp(ver, ver_shema + i) <= 0;
	}
	if(!strncmp("=", ver_shema + i, 1)) {
		++i;
		while(ver_shema[i] == ' ' || ver_shema[i] == '\t')
			i++;
		return version_cmp(ver, ver_shema + i) == 0;
	}
	return version_cmp(ver, ver_shema + i) == 0;
}
/*
bool Version::dep_ver_chk(char *ver_shema) {
	return _dep_ver_chk(version_str, ver_shema);
}*/

bool Version::dep_ver_chk(const char *real_ver) {
	return _dep_ver_chk(real_ver, version_str);
}

bool Version::operator<(Version_iface &ver) {
	return version_cmp(version_str, ver.getstring())<0;
}

bool Version::operator>(Version_iface &ver) {
	return version_cmp(version_str, ver.getstring())>0;
}

bool Version::operator<=(Version_iface &ver) {
	return version_cmp(version_str, ver.getstring())<=0;
}

bool Version::operator>=(Version_iface &ver) {
	return version_cmp(version_str, ver.getstring())>=0;
}

bool Version::operator==(Version_iface &ver) {
	return version_cmp(version_str, ver.getstring())==0;
}

bool Version::operator!=(Version_iface &ver) {
	return version_cmp(version_str, ver.getstring())!=0;
}

void Version::operator=(Version_iface &ver) {
	if(version_str!=NULL)
		delete[] version_str;
	
	if(ver.getstring() == NULL)
		version_str = NULL;
	else {
		version_str = new char[strlen(ver.getstring()) + 1];
		strcpy(version_str, ver.getstring());
	}
}


bool Version::operator<(const char *ver) {
	return version_cmp(version_str, ver)<0;
}

bool Version::operator>(const char *ver) {
	return version_cmp(version_str, ver)>0;
}

bool Version::operator<=(const char *ver) {
	return version_cmp(version_str, ver)<=0;
}

bool Version::operator>=(const char *ver) {
	return version_cmp(version_str, ver)>=0;
}

bool Version::operator==(const char *ver) {
	return version_cmp(version_str, ver)==0;
}

bool Version::operator!=(const char *ver) {
	return version_cmp(version_str, ver)!=0;
}

void Version::operator=(const char *ver) {
	if(version_str!=NULL)
		delete[] version_str;
	
	if(ver == NULL)
		version_str = NULL;
	else {
		version_str = new char[strlen(ver) + 1];
		strcpy(version_str, ver);
	}
}
char *Version::getstring() {
	return version_str;
}

Version_iface *Version::copy() {
	return new Version(version_str);
}

Version::Version(const char *ver) {
	if(ver == NULL)
		version_str = NULL;
	else {
		version_str = new char[strlen(ver) + 1];
		strcpy(version_str, ver);
	}
}

Version::Version(Version_iface &ver) {
	if(ver.getstring() == NULL)
		version_str = NULL;
	else {
		version_str = new char[strlen(ver.getstring()) + 1];
		strcpy(version_str, ver.getstring());
	}
}

Version::~Version() {
	if(version_str != NULL)
		delete[] version_str;
}

