#include <abpmString.h>
#include <string.h>
#include <stdio.h>

inline int min(int i, int j) {return i<j?i:j;}
inline int max(int i, int j) {return i<j?j:i;}

abpmString::abpmString(const char *str) {
	len=strlen(str);
	data=new char[len+1];
	strcpy(data,str);
}

abpmString::~abpmString() {
	delete[] data;
}

abpmString::abpmString(abpmString& s) {
	len = s.len;
	data = new char[len+1];
	strcpy(data,s.data);
}

abpmString abpmString::operator+(abpmString& s) {
	int newlen = len+s.len;
	char *newdata=new char[newlen+1];
	strcpy(newdata, data);
	strcpy(newdata+len, s.data);
	return abpmString(newdata,newlen);
}

abpmString abpmString::operator+(const char *str) {
	int newlen = len+strlen(str);
	char *newdata=new char[newlen+1];
	strcpy(newdata, data);
	strcpy(newdata+len, str);
	return abpmString(newdata,newlen);
}

abpmString abpmString::operator+(const char c) {
	int newlen = len+1;
	char *newdata = new char[newlen+1];
	strcpy(newdata, data);
	newdata[newlen-1] = c;
	newdata[newlen] = '\0';
	return abpmString(newdata,newlen);
}
	
abpmString abpmString::operator+=(abpmString& s) {
	int newlen = len+s.len;
	char *newdata=new char[newlen+1];
	strcpy(newdata, data);
	strcpy(newdata+len, s.data);
	delete[] data;
	data=newdata;
	len=newlen;
	return *this;
}

abpmString abpmString::operator+=(const char *str) {
	int newlen = len+strlen(str);
	char *newdata=new char[newlen+1];
	strcpy(newdata, data);
	strcpy(newdata+len, str);
	delete[] data;
	data=newdata;
	len=newlen;
	return *this;
}
abpmString abpmString::operator+=(const char c) {
	int newlen = len+1;
	char *newdata = new char[newlen+1];
	strcpy(newdata, data);
	newdata[newlen-1] = c;
	newdata[newlen] = '\0';
	delete[] data;
	data=newdata;
	len=newlen;
	return *this;
}

abpmString abpmString::operator=(abpmString s) {
	delete[] data;
	len=s.len;
	data = new char[len+1];
	strcpy(data,s.data);
	return *this;
}

abpmString operator+(char *str, abpmString s) {
	int origlen = strlen(str);
	int newlen = s.getLength() + origlen;;
	char *newdata=new char[newlen+1];
	strcpy(newdata, str);
	strcpy(newdata+origlen, s.getStr());
	return abpmString(newdata,newlen);
}

abpmString abpmString::operator+(int i) {
	char *intstr = new char[3*sizeof(int)]; //It's enough in all architecture:-)
	sprintf(intstr, "%d", i);
	int newlen = strlen(intstr) + len;
	char *newstr = new char[newlen + 1];
	strcpy(newstr, data);
	strcpy(newstr+len, intstr);
	return abpmString(newstr, newlen);
}

abpmString abpmString::head(int i) {
	int newlen=min(i,len);
	if(newlen<0)
		newlen=0;
	char *newstr=new char[newlen+1];
	for(int j=0; j<newlen; j++)
		newstr[j]=data[j];
	newstr[newlen]='\0';
	return abpmString(newstr,newlen);
}

abpmString abpmString::tail(int i) {
	int newlen=min(max(len-i,0),len);
	char *newstr=new char[newlen+1];
	for(int j=0; j<newlen; j++)
		newstr[j]=data[j + len - newlen];
	newstr[newlen]='\0';
	return abpmString(newstr,newlen);
}

bool abpmString::eq(abpmString& s) {
	bool retval = (strcmp(s.data, data)==0);
	return retval;
}

bool abpmString::eq(const char *s) {
	bool retval = (strcmp(s, data)==0);
	return retval;
}

bool abpmString::eq(abpmString& s, int n) {
	bool retval = (strncmp(s.data, data, n)==0);
	return retval;
}

bool abpmString::eq(const char *s, int n) {
	bool retval = (strncmp(s, data, n)==0);
	return retval;
}

/*operator abpmString(char *str) {
	return abpmString(str);
}*/
